c***********************************************************************
      Subroutine MixMat(debug,nmat,MMatrix,ZMix,EMix)

c Subroutine that determines the ordered mass eigenvalues and
c eigenvectors of the scalar mass matrix MMatrix
c***********************************************************************

      Implicit NONE

c Input
      Integer debug
      Integer nmat
      
      Double Complex MMatrix(nmat,nmat)
c Output
      Double Complex ZMix(nmat,nmat)
      Double Precision EMix(nmat)

c Local Variables
      Integer ierr,i,j
      Double Precision rwork(3*nmat-2)
      Double Complex work(2*nmat)
      
      Call ZHEEV('V','U',nmat,MMatrix,nmat,EMix,work,2*nmat,rwork,ierr)

      Do i=1,nmat
         If (EMix(i).le.0.D0) Then
            EMix(i)=-SQRT(-EMix(i))
         Else
            EMix(i)=SQRT(EMix(i))
         End If
         Do j=1,nmat
            ZMix(i,j)=DCONJG(MMatrix(j,i))
         End Do
      End Do
      
c      do i=1,6
c       do j=1,6
c        print*,i,j,ZMix(i,j)
c       enddo
c      enddo

c      stop
   
      If (debug.eq.1) Then
         Do i=1,nmat
            Do j=1,nmat
               Write(*,'(A,I2,A,I2,A,G15.7,G15.7)') 
     &              'ZMix(',i,',',j,')=',ZMix(i,j)
            End Do
         End Do
         
         Do i=1,nmat
            Write(*,'(A,I2,A,G15.7,G15.7)') 'EMix(',i,')=',EMix(i)
         End Do
      End If
      
      
      Return
      End
