c***********************************************************************
      Subroutine slepmass(debug)

c Subroutine that determines the mixing of the sleptons and sneutrinos
c outputting the various masses and mixing matrices.
c***********************************************************************

      Implicit NONE

      Include 'insoft.h'
      Include 'vars.h'

c Inputs
      Integer debug

c Local
      Double Complex MIElS(6,6),MINeS(3,3)
      
c Obtain the mass matrix for the sleptons
      If (debug.eq.1) Then
         Write(*,*) '***************************************'
         Write(*,*) 'Selectron Mass Matrix'
      End If
      Call MassMatrix(debug,3,6,MIElS)
      If (debug.eq.1) Then
         Write(*,*) '***************************************'
         Write(*,*) 'Selectron Diagonalization'
      End If
      Call MixMat(debug,6,MIElS,ZSE,MElS)
      
c Obtain the mass matrix for the sneutrinos
      If (debug.eq.1) Then
         Write(*,*) '***************************************'
         Write(*,*) 'Sneutrino Mass Matrix'
      End If
      Call MassMatrix(debug,4,3,MINeS)
      If (debug.eq.1) Then
         Write(*,*) '***************************************'
         Write(*,*) 'Sneutrino Diagonalization'
      End If
      Call MixMat(debug,3,MINeS,ZSN,MNeS)


      Return
      End
