c***********************************************************************
      Subroutine BDInit(debug,init)

c Subroutine that initialises the various variables relevant to the
c BDecay routines including the strong running coupling routines and
c the variables relevant to the various decays.
c***********************************************************************

      Implicit NONE

      Include 'insm.h'
      Include 'insoft.h'
      Include 'vars.h'
      Include 'const.h'


      Integer debug,init

      Integer i,j

      Double Precision m_q(3),m_l(3),mu_l(3),alphaStr, Pole2SI
      Integer nf,t_q(3)
 
c***********************************************************************

    
      If (init.eq.0.or.init.eq.1) Then
         If (debug.eq.1) Then
            Write(*,*) '***************************************'
            Write(*,*) 'Standard Model Parameters check'
            Write(*,*) 'Lepton Masses', m_el(1), m_el(2), m_el(3)
            Write(*,*) 'Down Quark Masses', m_do(1), m_do(2), m_do(3)
            Write(*,*) 'Down Quark Scales', mu_do(1), mu_do(2), mu_do(3)
            Write(*,*) 'Up Quark Masses', m_up(1), m_up(2), m_up(3)
            Write(*,*) 'Up Quark Scales', mu_up(1), mu_up(2), mu_up(3)
            Write(*,*) 'Electroweak Sector', mz,mw, sw2, GFermi
            Write(*,*) 'alphas + scale', alphas_0, mualphas_0
            Write(*,*) '***************************************'
            Write(*,*) 'CKM Matrix'
            Do i=1,3
               Do j=1,3
                  Write(*,'(A,I2,A,I2,A,G15.7,G15.7)')
     &                 'KM(',i,',',j,')=',KM(i,j)
               End Do
            End Do
         End If
  

       
c***********************************************************************

         Do i=1,6
            Do j=1,6
               Unit6(i,j)=DCMPLX(0.D0,0.D0)
            End Do
            Unit6(i,i)=DCMPLX(1.D0,0.D0)
         End Do
         
         Do i=1,3
            Do j=1,3
               Unit3(i,j)=DCMPLX(0.D0,0.D0)
            End Do
            Unit3(i,i)=DCMPLX(1.D0,0.D0)
         End Do
         
         Do i=1,2
            Do j=1,2
               Unit2(i,j)=DCMPLX(0.D0,0.D0)
            End Do
            Unit2(i,i)=DCMPLX(1.D0,0.D0)
         End Do
        
c***********************************************************************
c Inputs for strong coupling routines, quark masses, alpha_s(mu) 
         m_l(1)=m_do(1)
         m_l(2)=m_up(1)
         m_l(3)=m_do(2)
         m_q(1)=m_up(2)
         m_q(2)=m_do(3)
         m_q(3)=m_up(3)
         
         mu_l(1)=mu_do(1)
         mu_l(2)=mu_up(1)
         mu_l(3)=mu_do(2)
         
         If (mu_up(2).eq.0.D0) Then
            t_q(1)=1
         Else
            t_q(1)=0
         End If
         
         If (mu_do(3).eq.0.D0) Then
            t_q(2)=1
         Else
            t_q(2)=0
         End If
         
         If (mu_up(3).eq.0.D0) Then
            t_q(3)=1
         Else
            t_q(3)=0
         End If
         
         nf=5
         
         Call StrSetup(alphaS_0,mualphaS_0,nf,m_q,t_q,m_l,mu_l)
         
         If (debug.eq.1) Then
            Write(*,*) '***************************************'
            Write(*,*) 'alpha_s running check'
            Write(*,*) 'as at top mass', alphaStr(178.D0,5,4)
            Write(*,*) 'as at mz', alphaStr(91.D0,5,4)
            Write(*,*) 'as at mb', alphaStr(5.D0,5,4)
         End If
         
         If (mu_up(2).eq.0.D0) Then
            m_up(2)=Pole2SI(m_up(2),4,3,4)
            mu_up(2)=m_up(2)
         End If
         
         If (mu_do(3).eq.0.D0) Then
            m_do(3)=Pole2SI(m_do(3),5,4,4)
            mu_do(3)=m_up(2)
         End If
         
         If (mu_up(3).eq.0.D0) Then
            m_up(3)=Pole2SI(m_up(3),6,5,4)
            mu_up(3)=m_up(3)
         End If
      End If

c***********************************************************************
c Initialize the various parameters required for the BDecay routines


      If (init.eq.0.or.init.eq.2) Then
         Call bbsetup(debug)
         Call bsgsetup(debug)
         Call bsmsetup(debug)
      End If



c***********************************************************************

      Return
      End
