c***********************************************************************

      Subroutine trsoft(debug)

c Subroutine that calculates the transformed soft terms.
c U_L MSoftUpL U_L^{dag}
c D_L MSoftDoL D_L^{dag}
c D_R MSoftDoR D_R^{dag}
c U_R MSoftUpR U_R^{dag}
c D_L AD^* D_R^{dag}
c U_L AU^* U_R^{dag}
c***********************************************************************

      Implicit NONE

      Include 'insoft.h'
      Include 'vars.h'
      Include 'rs.h'

c Inputs
      Integer debug

c Local
      Integer i,j,k,l
      Double Complex tmp1,tmp2,tmp3,tmp4,tmp5,tmp6

c***********************************************************************
c Determine the matrices D_L, D_R, U_L and U_R

      Call SVDmat(debug,3,mdbare,ZBDR,ZBDL,mdbarediag)

      Call SVDmat(debug,3,mubare,ZBUR,ZBUL,mubarediag)

c***********************************************************************
c Determine the transformed soft terms

      Do i=1,3
         Do j=1,3
            tmp1=DCMPLX(0.D0,0.D0)
            tmp2=DCMPLX(0.D0,0.D0)
            tmp3=DCMPLX(0.D0,0.D0)
            tmp4=DCMPLX(0.D0,0.D0)
            tmp5=DCMPLX(0.D0,0.D0)
            tmp6=DCMPLX(0.D0,0.D0)
            Do k=1,3
               Do l=1,3
                  tmp1=tmp1+ZBDL(i,k)*BBMSoftQuL(k,l)*DCONJG(ZBDL(j,l))
                  tmp3=tmp3+ZBDR(i,k)*BBMSoftDoR(k,l)*DCONJG(ZBDR(j,l))
                  tmp4=tmp4+ZBUR(i,k)*BBMSoftUpR(k,l)*DCONJG(ZBUR(j,l))
                  tmp5=tmp5
     &                 +ZBDL(i,k)*DCONJG(BBADo(k,l))*DCONJG(ZBDR(j,l))
                  tmp6=tmp6
     &                 +ZBUL(i,k)*DCONJG(BBAUp(k,l))*DCONJG(ZBUR(j,l))
               End Do
            End Do
            MSoftQuL(i,j)=tmp1
            MSoftDoR(i,j)=tmp3
            MSoftUpR(i,j)=tmp4
            ADo(i,j)=DCONJG(tmp5)
            AUp(i,j)=DCONJG(tmp6)
         End Do
      End Do

      Return
      End
