*****************************************************************************
*** Program ascii2bin converts system-independent ascii data files to
*** system-dependent binary files.
*** Author: Joakim Edsjo  edsjo@teorfys.uu.se
*** Date: 97-12-03
*** Modified: -
*****************************************************************************

      program ascii2bin
      implicit none


C------------------------ Variables ------------------------------------

      real phitmp(0:90)
      integer i,j,k,l,m,flxkfile,thn,zn,milow(6)
      character*50 filein
      character*50 fileout
      character*255 scr
      character*10 scr2
      character*1 inp

C----------------------------------------- Set-up common block variables

      write(*,*)
      write(*,*) '***************************************************'
      write(*,*) '*** Welcome to ascii2bin 1.0 (Dec 03, 1997)     ***'
      write(*,*) '*** This program converts system-independent    ***'
      write(*,*) '*** ascii data files generated by mktab (v3.2)  ***'
      write(*,*) '*** to system-dependent binary files            ***'
      write(*,*) '***************************************************'   
      write(*,*)


c... Number of bins in tables
c... The actual table in the file covers 0:n-1 but the variable in
c... memory is bigger to make interpolation at edges simple
      thn=90  ! Number of bins in theta
      zn=50   ! Number of bins in z

c...Lowest mass index for channel j
      milow(1)=1   ! c c-bar
      milow(2)=1   ! b b-bar
      milow(3)=8   ! t t-bar
      milow(4)=1   ! tau+ tau-
      milow(5)=4   ! W+ W-
      milow(6)=5   ! Z Z

C------------------------------------------------------ Load muon tables

      write(*,*) 'Integrated or differential fluxes? (i/d)'
      read(5,'(a)') inp
      write(*,*) inp

      if (inp.eq.'i'.or.inp.eq.'I') then

c...Integrated fluxes
        write(*,*) 'Enter input file name for integrated muon flux',
     &    ' tables (ascii):'
        read(5,'(a)') filein
        write(*,*) filein
        write(*,*) 'Enter output file name for binary file:'
        read(5,'(a)') fileout
        write(*,*) fileout

        write(*,*) 'Loading integrated muon flux tables from file ',
     &    filein
        write(*,*) 'and saving to file ',fileout
        open(unit=13,file=filein,status='old',form='formatted')
        open(unit=14,file=fileout,status='unknown',form='unformatted')
        read(13,500) scr2,flxkfile
        read(13,'(a)') scr
 500    format(1x,A10,1x,I3)
        write(14) flxkfile

        do i=1,2
          if (i.eq.1) then
            write(*,*) '   ...for the Sun...'
          else
            write(*,*) '   ...for the Earth...'
          endif
          do j=1,6
            write(*,*) '      channel number ',j
            do k=1,18
              if (k.ge.milow(j)) then
                do l=0,zn-1
                  read(13,2000) (phitmp(m),m=0,thn)
                  write(14) (phitmp(m),m=0,thn)
                enddo
              endif
            enddo
          enddo
        enddo
        close(13)
        close(14)
   
      else ! differential fluxes

c...Differential fluxes
        write(*,*) 'Enter input file name for differential muon flux',
     &    ' tables (ascii):'
        read(5,'(a)') filein
        write(*,*) filein
        write(*,*) 'Enter output file name for binary file:'
        read(5,'(a)') fileout
        write(*,*) fileout

        write(*,*) 'Loading differential muon flux tables from file ',
     &    filein
        write(*,*) 'and saving to file ',fileout
        open(unit=13,file=filein,status='old',form='formatted')
        open(unit=14,file=fileout,status='unknown',form='unformatted')
        read(13,500) scr2,flxkfile
        read(13,'(a)') scr
        write(14) flxkfile
      
        do i=1,2
          if (i.eq.1) then
            write(*,*) '   ...for the Sun...'
          else
            write(*,*) '   ...for the Earth...'
          endif
          do j=1,6
            write(*,*) '      channel number ',j
            do k=1,18
              if (k.ge.milow(j)) then
                do l=0,zn-1
                  read(13,2000) (phitmp(m),m=0,thn)
                  write(14) (phitmp(m),m=0,thn)
                enddo
              endif
            enddo
          enddo
        enddo
        close(13)
        close(14)

      endif
        
      write(*,*) 'Reading and writing of data files completed.'
 
 2000 format(91(1x,E12.6))

      end


















