      real*8 function Delta1_td(t,gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'

      integer t,gd

      real*8 H_1
     
c ------------- local --------------

      integer lsd1, lsd2
      real*8 mas_sd1,  mas_sd2, x1, x2

c ---------------------------------

      
      lsd1 = 2*gd+28
      lsd2 = lsd1+1


      mas_sd1 = dmax1(mass(lsd1),mass(lsd2))
      mas_sd2 = dmin1(mass(lsd1),mass(lsd2))




      x1 = (mas_sd1/mass(kgluin))**2.0d0
      x2 = (mas_sd2/mass(kgluin))**2.0d0



      If (t.eq.0) then
        Delta1_td = - 3.0d0/4.0d0
     &              - 1.0d0/2.0d0*H_1(x2)
      else
        Delta1_td = - 3.0d0/4.0d0
     &              - 1.0d0/2.0d0*H_1(x1) 
      endif

      return
      end

      real*8 function Delta2_td(t,gd)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'sheffaccom.h'

      integer t,gd

      real*8 H_1,H_2,H_3
     
c ------------- local --------------

      integer lsu1, lsu2, lsd1, lsd2
      real*8 mas_sd1, mas_sd2,  mas_st1, mas_st2, x1, x2 
     &    , u1, u2,  cottht

c ---------------------------------

      
      lsd1 = 2*gd+28
      lsd2 = ksd1+1


      mas_sd1 = dmax1(mass(lsd1),mass(lsd2))
      mas_sd2 = dmin1(mass(lsd1),mass(lsd2))
      mas_st1 = dmax1(mass(ksqu(3)),mass(ksqu(6)))
      mas_st2 = dmin1(mass(ksqu(3)),mass(ksqu(6)))   

      x1 = (mas_sd1/mass(kgluin))**2.0d0
      x2 = (mas_sd2/mass(kgluin))**2.0d0
      u1 = (mas_st1/mass(kgluin))**2.0d0   
      u2 = (mas_st2/mass(kgluin))**2.0d0 

      cottht = squlmx(3,3)/squrmx(3,3)


      If (t.eq.0) then
        Delta2_td = 5.0d0/2.0d0+(1.0d0
     &     - cottht*mass(kt)*mass(kgluin)/mas_sd2**2.0d0)*H_3(x2)
     &     + 1.0d0/2.0d0*H_1(x1)+1.0d0/2.0d0*H_1(x2)
     &     - 2.0d0*(asoftd(gd/2)-mu*tanbe)/mass(kgluin)*H_2(x1,x2)
      else
        Delta2_td = 5.0d0/2.0d0+H_3(x1)
     &     + 1.0d0/2.0d0*H_1(u1)+1.0d0/2.0d0*H_1(u2)
     &     - 2.0d0*(asoftu(3)-mu/tanbe)/mass(kgluin)*H_2(u1,u2)
      endif

      return
      end
c
      real*8 function H_3(x)
      
      implicit none
      
      real*8 x

      If(x .eq. 1.0d0) then 
       H_3 = -2.0d0
      else 
       H_3 = 2.0d0*x/(1-x)*dlog(x)
      end if 

      return
      end

















