      real*8 function E_SM(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      

      real*8 x, y

      y = x-1.0d0

      If(x .eq. 1.0d0) then
       E_SM = 43.0d0/72.0d0
      else
       E_SM =
     &    x*(-18.0d0+11.0d0*x+x**2.0d0)/12.0d0/y**3.0d0
     &  + x**2.0d0*(15.0d0-16.0d0*x
     &               +4*x**2.0d0)/6.0d0/y**4.0d0*dlog(x) 
     &  - 2.0d0/3.0d0*dlog(x)      
      endif 

      return
      end

      real*8 function E_H(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'sheffaccom.h'

      real*8 arg, fun, factor

      fun = arg-1.0d0


      If(x .eq. 1.0d0) then
       factor = 1.0d0/8.0d0
      else
       factor =
     &    arg*(16.0d0-29.0d0*arg
     &            +7.0d0*arg**2.0d0)/36.0d0/fun**3.0d0
     &  + arg*(3.0d0*arg-2.0d0)/6.0d0/fun**4.0d0*dlog(arg) 
      endif
       
      E_H = Au**2.0d0*factor
 
      return
      end

      real*8 function E_chi(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none

      real*8 x, y

      y = x-1.0d0

      If(x .eq. 1.0d0) then
        E_chi = 1.0d0/12.0d0
      else
        E_chi =
     &    x*(11.0d0-7.0d0*x
     &            +2.0d0*x**2.0d0)/18.0d0/y**3.0d0
     &  - x/3.0d0/y**4.0d0*dlog(x) 
      endif
   
 
      return
      end




