      real*8 function G8_SM(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      
      real*8 x,y
c----- function
      real*8 RLI2    

      y = x-1.0d0

      If(x .eq. 1.0d0) then
       G8_SM = -9821.0d0/12960.0d0
      else
       G8_SM =
     &  (-4.0d0*x**4.0d0+40.0d0*x**3.0d0+41.0d0*x**2.0d0
     &     +x)/6.0d0/y**4.0d0*RLI2(y/x)
     &  +(-17.0d0*x**3.0d0
     &     -31.0d0*x**2.0d0)/2.0d0/y**5.0d0*dlog(x)**2.0d0
     &  +(-210.0d0*x**5.0d0+1086.0d0*x**4.0d0+4893.0d0*x**3.0d0
     &     +2857.0d0*x**2.0d0-1994.0d0*x
     &     +280.0d0)/216.0d0/y**5.0d0*dlog(x)
     &  +(737.0d0*x**4.0d0-14102.0d0*x**3.0d0
     &     -28209.0d0*x**2.0d0+610.0d0*x
     &     -508.0d0)/1296.0d0/y**4.0d0
      endif

      return
      end

      real*8 function G8_H(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9710335
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'sheffaccom.h'   
      
      real*8 arg,fun,G1_H,G2_H
c----- function
      real*8 RLI2  

      fun = arg-1.0d0

      If(arg .eq. 1.0d0) then
        G1_H = -181.0d0/72.0d0
        G2_H = 301.0d0/720.0d0
      else
        G1_H =
     &  (-36.0d0+25.0d0*arg
     &        -17.0d0*arg**2.0d0)/2.0d0/fun**3.0d0*RLI2(fun/arg)
     &  +(19.0d0+17.0d0*arg)/fun**4.0d0*dlog(arg)**2.0d0
     &  +(-3.0d0-187*arg+12.0d0*arg**2.0d0
     &     -14.0d0*arg**3.0d0)/4.0d0/fun**4.0d0*dlog(arg)
     &  +3.0d0*(143.0d0-44.0d0*arg
     &     +29*arg**2.0d0)/8.0d0/fun**3.0d0

        G2_H =
     &  arg*(30.0d0-17.0d0*arg
     &     + 13.0d0*arg**2.0d0)/fun**4.0d0*RLI2(fun/arg)
     &  -arg*(31.0d0+17.0d0*arg)/fun**5.0d0*dlog(arg)**2.0d0
     &  +(-226.0d0+817.0d0*arg+1353.0d0*arg**2.0d0
     &     + 318.0d0*arg**3.0d0
     &     + 42.0d0*arg**4.0d0)/36.0d0/fun**5.0d0*dlog(arg)
     &  +(1130.0d0-18153.0d0*arg+ 7650*arg**2.0d0
     &     - 4451.0d0*arg**3.0d0)/216.0d0/fun**4.0d0
      endif 
     

      G8_H = arg*(1.0d0/3.0d0*Au*Ad*G1_H
     &   + 1.0d0/6.0d0*Au**2.0d0*G2_H)  

      return
      end

      real*8 function G8_1chi(arg,i)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'      

      integer i
      real*8 arg,temp
c---- function
      real*8 RLI2, F8_1, Delta1_td    

      temp = arg-1.0d0

      If(arg .eq. 1.0d0) then
        G8_1chi = 
     & - 8.0d0/9.0d0*F8_1(arg)*(Delta1_td(1,4)+Delta1_td(1,6)
     &       - 1.0d0+ 6.0d0*dlog(mass(kw)/mass(kcha(i))))
     & + 17.0d0/54.0d0 !From Limit
      else
        G8_1chi =
     & - 8.0d0/9.0d0*F8_1(arg)*(Delta1_td(1,4)+Delta1_td(1,6)
     &       - 1.0d0+ 6.0d0*dlog(mass(kgluin)/mass(kcha(i))))
     & - arg*(1210.0d0-437.0d0*arg
     &       - 1427.0d0*arg**2.0d0)/648.0d0/temp**3.0d0
     & - arg**2.0d0*(49.0d0+46.0d0*arg
     &       + 9.0d0*arg**2.0d0)/12.0d0/temp**4.0d0*RLI2(temp/arg)
     & - arg*(85.0d0-603.0d0*arg-387*arg**2.0d0
     &       + 78.0d0*arg**3.0d0)/108.0d0/temp**4.0d0*dlog(arg)
     & - 13.0d0*arg**2.0d0/3.0d0/temp**3*dlog(arg)**2.0d0
      endif 
     
      return
      end

      real*8 function G8_2chi(arg)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      
      integer i
      real*8 arg,temp
c---- function
      real*8 RLI2, F8_3, Delta1_td, Delta2_td   

      temp = arg-1.0d0

      If(arg .eq. 1.0d0) then
        G8_2chi =
     & - 4.0d0/3.0d0*F8_3(arg)*(Delta1_td(1,4)+Delta1_td(0,6)
     &       + Delta2_td(0,6)-2.0d0)
     & - 71.0d0/54.0d0 !From Limit 
      else
        G8_2chi =
     & - 4.0d0/3.0d0*F8_3(arg)*(Delta1_td(1,4)+Delta1_td(0,6)
     &       + Delta2_td(0,6)-2.0d0)
     & - (61.0d0-39.0d0*arg)/12.0d0/temp**2.0d0
     & - 4.0d0*arg*(3.0d0
     &       + 4.0d0*arg)/3.0d0/temp**3.0d0*RLI2(temp/arg)
     & - (7.0d0-60.0d0*arg
     &       - 14*arg**2.0d0)/6.0d0/temp**3.0d0*dlog(arg)
     & - 14.0d0*arg/3.0d0/temp**3*dlog(arg)**2.0d0
      endif
  
      return
      end
      
      real*8 function G8_W(x)
c_______________________________________________________________________
c  function in giudice et al, hep-ph/9806308
c  author: roberto ruiz
c=======================================================================
      implicit none
      
      real*8 x,y
c---- function
   

      y = x-1.0d0
  
      If(x .eq. 1.0d0) then
       G8_W = 1.0d0/8.0d0
      else
       G8_W =
     &  - (4.0d0-5.0d0*x-5.0d0*x**2.0d0)/12.0d0/y**3.0d0
     &  + x*(1.0d0-2.0d0*x)/2.0d0/y**4.0d0*dlog(x)
      endif
 
      return
      end






