      subroutine ddsetloop(opt)
c...set parameters for calculating QCD corrections in 
c...neutralio-nucleon cross section 
c...opt - character string specifying choice to be made
c...author: roberto ruiz
  
      implicit none
      include 'dssusy.h'
      include 'sheffdd.h'

      character*(*) opt

c------ parameters fixed as in Drees and Nojiri(prd48(93)3483)

      alpha_s_mu0 = 0.12d0
      alpha_s_Q0 = 0.21d0
      r_alpha = alpha_s_mu0/alpha_s_Q0

      Q0 = 5.0d0
      mu0 = dsqrt(mass(ksqu(1))**2.0d0-mass(kn(kln))**2.0d0) !to be checked      

c------ models taken from Drees and Nojiri(prd48(93)3483)      
       
      if(opt.eq.'MTB1' .or. opt.eq.'default') then
         O_pls = 0.025d0
         Ou_mns_Od_p = 0.115d0
         Ou_mns_Od_n =  -0.181d0
         Sigma = 0.509d0
         G_2 = 0.492d0
      else if(opt.eq.'MTB2') then
         O_pls = 0.056d0
         Ou_mns_Od_p = 0.102d0
         Ou_mns_Od_n =  -0.190d0
         Sigma = 0.540d0
         G_2 = 0.471d0       
      else if(opt.eq.'MTLO') then
         O_pls = 0.019d0
         Ou_mns_Od_p = 0.113d0
         Ou_mns_Od_n =  -0.181d0
         Sigma = 0.503d0
         G_2 = 0.480d0        
      else if(opt.eq.'Owens') then
         O_pls = 0.018d0
         Ou_mns_Od_p = 0.109d0
         Ou_mns_Od_n =  -0.171d0
         Sigma = 0.502d0
         G_2 = 0.514d0
     
c...  invalid choice
      else
            write (*,*) 
     &           'dsddloop: unrecognized spin-independent option ',opt
            stop
      endif   
        
      return
      end
      




