
      FUNCTION ALFE(Q)
C----------------------------------------------------------------------
C
C     Returns the running EM coupling alpha_em(q)
C
C-----SEE BARGER/PHILLIPS, P. 202 ---------------------------
c+SELF,IF=IMPNONE
      IMPLICIT NONE
c+SELF
c+CDE,SSLUN
      REAL*8 ALFE,Q
      REAL*8 PI,MB,SUM,A0,QD,QU,MS,ME,QS,MM,MD,MU,MTAU,MC
      DATA ME/.0005/,MM/.105/,MTAU/1.784/,MU/.01/,MD/.01/
      DATA MS/.5/,MC/1.6/,MB/5.0/,PI/3.1415926/
C
      QS=Q**2.0D0
      SUM=0.
      QU=2./3.
      QD=-1./3.
      IF (Q.GT.ME) SUM=SUM+LOG(QS/ME**2)
      IF (Q.GT.MM) SUM=SUM+LOG(QS/MM**2)
      IF (QS.GT.MTAU) SUM=SUM+LOG(QS/MTAU**2)
      IF (QS.GT.MU) SUM=SUM+3*QU**2*LOG(QS/MU**2)
      IF (QS.GT.MD) SUM=SUM+3*QD**2*LOG(QS/MD**2)
      IF (QS.GT.MS) SUM=SUM+3*QD**2*LOG(QS/MS**2)
      IF (QS.GT.MC) SUM=SUM+3*QU**2*LOG(QS/MC**2)
      IF (QS.GT.MB) SUM=SUM+3*QD**2*LOG(QS/MB**2)
      A0=1./137.
      ALFE=A0/(1.-A0/3./PI*SUM)
      RETURN
      END
