      FUNCTION MQCD(KQ,Q)
C----------------------------------------------------------------------
C
C       This function returns the 3-loop running mass for heavy quarks.
C       Computations are performanced according to hep-ph/9712201.
C       Effects across the thersholds are taken account. These
C
C
C----------------------------------------------------------------------

      IMPLICIT NONE
      INCLUDE 'dssusy.h'
     
      INTEGER KQ
      REAL*8 Q
      REAL*8 MQCD,RMASS,ALFS

c local
 
      INTEGER K(12),NTH,I,KTH(2),KQTH
      REAL*8 MQ !MCMC,MBMB,MTM
      REAL*8 XN,RENORM
      REAL*8 MS(0:2)
       


C BEGIN

C CALCULATING RUNNING MASSES AT Q.       

    
      MS(0)=0.0D0       
      DO I=1,2
       KTH(I)=0
       MS(I)=0.0D0
      ENDDO 
      
      IF(KQ.EQ.KC) THEN
        IF(Q.LT.MCMC) THEN
          WRITE(*,*) 'WRONG VALUE FOR SCALE, THIS CAN NOT
     $                 BE LESS THAN mq(mq)'
          STOP
        ELSE IF(Q.LT.MBMB) THEN
          NTH=0
        ELSE IF(Q.GE.MBMB.AND.Q.LT.MTMT) THEN
          NTH=1
          KTH(NTH)=KB
        ELSE
          NTH=2
          KTH(NTH-1)=KB
          KTH(NTH)=KT
        ENDIF
      ELSE IF(KQ.EQ.KB) THEN
c        IF(Q.LT.MBMB) THEN
c          WRITE(*,*) 'WRONG VALUE FOR SCAL, THIS CAN NOT
c     $                 BE LESS THAN mq(mq)'
c          STOP
         IF(Q.LT.MTMT) THEN
          NTH=0
        ELSE
          NTH=1
          KTH(NTH)=KT          
        ENDIF
      ELSE IF(KQ.EQ.KT) THEN
c        IF(Q.LT.MTMT) THEN
c          WRITE(*,*) 'WRONG VALUE FOR SCALE, THIS CAN NOT
c     $                 BE LESS THAN mq(mq)'
c        STOP
c        ELSE
         NTH=0
c        ENDIF
      ELSE
        WRITE(*,*) 'ONLY HEAVY QUARKS(kc,kb or kt)'
        STOP      
      ENDIF
      
      MS(0)=RMASS(KQ,Q)

      DO I=0,NTH
        IF(I.LT.NTH) THEN
          KQTH=KTH(I+1)
          XN=2.0D0*DLOG(RMASS(KQTH,Q)/Q)
          RENORM=(1.0D0+1.0D0/12.0D0*(ALFS(Q)/PI)**2.0D0
     $                   *(XN**2.0D0+5.0D0/3.0D0*XN+89.0D0/36.0D0))
          MS(I+1)=MS(I)/RENORM  
        ENDIF
      ENDDO

      MQCD=MS(NTH)

      RETURN
      END
 
      
      



