      FUNCTION MQED(KF,Q)
C----------------------------------------------------------------------
C
C       This function returns the 1-loop running mass for heavy lepton.
C       Computations are performanced according to hep-ph/9712201.
C       Effects across the thersholds are not taken account (I am
C       thinking adding thresholds effects)
C
C----------------------------------------------------------------------

      IMPLICIT NONE
      INCLUDE 'dssusy.h'
     
      INTEGER KF
      REAL*8 Q
      REAL*8 MQED,ALFE

c local
 
      REAL*8 MF,MTAU,T
   
      DATA  MTAU/1.777d0/           
      
C BEGIN

C CALCULATING RUNNING MASSES AT Q.       


      
      IF(KF.EQ.KTAU) THEN
        IF(Q.LT.MTAU) THEN
          WRITE(*,*) 'WRONG VALUE FOR SCALE, THIS CAN NOT
     $                 BE LESS THAN MTAU'
          STOP
        ELSE 
c          MF=MTAU
           MF=MASS(KTAU)
        ENDIF
       ELSE
        WRITE(*,*) 'ONLY HEAVY LEPTON(ktau)'
        STOP      
      ENDIF

      T=2.0D0*DLOG(Q/MF)

      MQED=MF*(1.0d0-ALFE(Q)/PI*(1.0D0+3.0D0/4.0D0*T))




      RETURN
      END
 
      
      



