      FUNCTION RQCD(KQ,Q)

      IMPLICIT NONE
      INCLUDE 'dssusy.h'

      INTEGER KQ
      REAL*8 Q
      
      INTEGER NEFF
      REAL*8 ZRi3
      PARAMETER (ZRi3 = 1.2021d0) !Riemman Z-function in 3.
      REAL*8 MCH,MBT,MTP,MQ !,MBMB,MTMT
      REAL*8 G0,G1,G2,B0,B1,B2, RQCD_Q, RQCD_POLE
      REAL*8 FACTOR

      REAL*8 RQCD,ALFS

      MTP=mass(kt)
      MBT=mass(kb)
      MCH=mass(kc)


      IF(KQ.EQ.KC) THEN 
         NEFF=4
         MQ=MCH
      ELSE IF(KQ.EQ.KB) THEN
         MQ=MBT
         IF(Q.LT.MBMB) THEN
          NEFF=4
         ELSE
          NEFF=5
         ENDIF
      ELSE
         MQ=MTP
         IF(Q.LT.MTMT) THEN
          NEFF=5
         ELSE
          NEFF=6
         ENDIF
      ENDIF


      G0=2.0D0
      G1=101.0D0/12.0D0-5.0D0/18.0D0*NEFF
      G2=1.0D0/32.0D0*(1249.0D0
     $         -(2216.0D0/27.0D0+160.0D0/3.0D0*ZRi3)*NEFF
     $         -140.0D0/81.0D0*NEFF**2.0D0)
      
      B0=11.0D0-2.0D0/3.0D0*NEFF
      B1=51.0D0-19.0D0/3.0D0*NEFF
      B2=2857.0D0-5033.0D0/9.0D0*NEFF+325.0D0/27.0D0*NEFF**2.0D0
      
      FACTOR=2.0D0*G1/B0-B1*G0/B0**2.0D0

      RQCD_Q=(B0*ALFS(Q)/2.0D0/PI)**(2.0D0*G0/B0)
     $   *(1.0D0+FACTOR*ALFS(Q)/PI
     $     +0*1.0D0/2.0D0*(FACTOR**2.0D0+2.0D0*G2/B0-B1*G1/B0**2.0D0
     $       -B2*G0/16.0D0/B0**2.0D0
     &        +B1**2.0D0*G0/2.0D0/B0**3.0D0)*(ALFS(Q)/PI)**2.0D0) 
      RQCD_POLE=(B0*ALFS(MQ)/2.0D0/PI)**(2.0D0*G0/B0)
     $   *(1.0D0+FACTOR*ALFS(MQ)/PI
     $     +0*1.0D0/2.0D0*(FACTOR**2.0D0+2.0D0*G2/B0-B1*G1/B0**2.0D0
     $       -B2*G0/16.0D0/B0**2.0D0
     &        +B1**2.0D0*G0/2.0D0/B0**3.0D0)*(ALFS(MQ)/PI)**2.0D0)
    
       RQCD= RQCD_Q/ RQCD_POLE      
     
  
      RETURN
      END
