**************************************************************
*** SUBROUTINE dsasfercode                                 ***
*** finds fermion kfer in a given family iifamv            ***
*** chow variable equal to                                 ***
*** 'same' : routine returns fermion code for the          ***
***          particles with the same iifamv                ***
*** 'diff' : routine returns fermion code for the          ***
***          particles with the same iifamv+1 or iifamv-1  ***
***                                                        *** 
*** AUTHOR: Piero Ullio, ullio@sissa.it                    ***
*** Date: 01-08-09                                         ***
**************************************************************

      subroutine dsasfercode(chow,iifamv,kfer)
      implicit none
      character*4 chow
      include 'dssusy.h'
      include 'dsascom.h'
      integer iifamv,kfer,iaux1,iaux2
*****      
      kfer=0
      iaux1=iifamv/10
      iaux2=iifamv-iaux1*10
*****
      if(iaux1.eq.ivfam(knue)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=knue
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=ke
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(knumu)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=knumu
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=kmu
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(knutau)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=knutau
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=ktau
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(ku)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=ku
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=kd
        endif
      elseif(iaux1.eq.ivfam(kc)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=kc
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=ks
        else
          goto 100 
        endif
      elseif(iaux1.eq.ivfam(kt)/10) then
        if((iaux2.eq.1.and.chow.eq.'same').or.
     &     (iaux2.eq.2.and.chow.eq.'diff')) then
          kfer=kt
        elseif((iaux2.eq.2.and.chow.eq.'same').or.
     &     (iaux2.eq.1.and.chow.eq.'diff')) then
          kfer=kb
        else
          goto 100 
        endif
      else  
        goto 100 
      endif
      return
***** something went wrong 
 100  continue
      write(*,*) 'error in dsassfercode'
      write(*,*) 'chow,iifamv =',chow,iifamv
      write(*,*) 'iaux1,iaxu2 =',iaux1,iaux2
      stop
      end
       
           
          
      
