      subroutine dsddsigsi(n,a,z,si)
c_______________________________________________________________________
c  neutralino nucleus cross section.
c  common:
c    'dssusy.h' - file with susy common blocks
c  input:
c    n : number of nuclear species
c    a : n-dim integer array with atomic numbers
c    z : n-dim integer array with charge numbers
c  output:
c    si : n-dim real*8 array with spin-independent cross sections
c    units: cm^2
c  author: paolo gondolo (paolo@physics.utah.edu) 2004
c=======================================================================
      implicit none
      include 'dssusy.h'
      include 'dsprep.h'
      include 'dsddcom.h'
      include 'dshacom.h'

      integer n,a(n),z(n)
      real*8 si(n)
      integer kx,i
      real*8 gev2cm2,mp,mn,mni,fkin,gps,gns,gpa,gna
c      real*8 j,sn,sp
      parameter (gev2cm2 = (197.327053d-16)**2)
      parameter (mp=0.93827231d0)
      parameter (mn=0.931494013d0)
      
      call dsddgpgn(gps,gns,gpa,gna)

      kx = kn(kln)
      mx = mass(kx)

      do i=1,n
         mni = z(i)*mp+(a(i)-z(i))*mn
         fkin = gev2cm2*(mni*mx/(mni+mx))**2/pi
         si(i) = fkin*(z(i)*gps+(a(i)-z(i))*gns)**2
c         sd(i) = fkin*(4.d0*(j+1.d0)/j)*(gpa*sp+gna*sn)**2
      enddo

      return
      end
