*********************************************************************
*** real*8 function dsepfr solar modulates the positron fraction at a
*** given energy (eep) for a Boost Factor (BF)
***         eep - positron energy in gev
***         BF - boost factor
*** output: dsepfr - solar modulated positron fraction
*** author: r ruiz
*******************************************************************


      function dsepfr(eep, BOF)

      implicit none

      real*8  eep, BOF
      real*8  phisusy,  phieptot
      real*8  dsepfr, dsepdiff, dsembg, dsepbg

      phisusy = BOF * dsepdiff(eep, 2, 4)


      phieptot =  phisusy + dsepbg(eep)


      dsepfr =  phieptot/(phieptot +  dsembg(eep))

      
      end







  
