function  mcharg_intp(DM, msnu)

!-------------------------------------------------------
! extract the LEPII chargino mass bound 
! whenever the lightest sneutrino mass is below 300 GeV
! author: Roberto Ruiz 
!-------------------------------------------------------

implicit none

integer, parameter :: dim = 4
real(8), intent(in) :: DM, msnu 

!local
REAL(8), dimension(dim) :: msnua, mcharga, y2a

real(8) :: mcharg_intp

!data from
msnua = (/150., 200., 250., 300./) 
mcharga = (/103., 103.166, 103.332, 103.5/)


mcharg_intp = 92.4d0 !absolute minimun for mSUGRA


if(DM.gt.3.d0) then
 if(msnu.gt.150.d0.or.msnu.lt.300) then
   call spline(msnua,  mcharga, DIM,  1.0e30, 1.0e30, y2a)
   call splint(msnua,  mcharga, y2a, DIM, msnu, mcharg_intp)
 else if (msnu.gt.300.d0) then 
    mcharg_intp = 103.5d0
 endif
endif     


end function mcharg_intp
