function dsfluxepfrac(egam, BOF)

 implicit none

 real(8) :: egam, BOF
 real(8) :: phisusy,  phieptot
 real(8) :: dsfluxepfrac, phiepbkg, phiebkg, fracbkg, dsepdiff, dsembg, dsepbg

  phisusy = BOF * dsepdiff(egam, 1, 4)

  phieptot =  phisusy + dsembg(egam) !phiepbkg(egam)

  dsfluxepfrac =  phieptot/(phieptot +  dsepbg(egam)) ! phiebkg(egam))


end function dsfluxepfrac



function phiepbkg(E)

 implicit none


 real (8) :: phiepbkg, E


!Fluxes of sec e+ in GeV^-1 cm^-2 s^-1 sr^-1    
 phiepbkg = 4.5d0 * E**(0.7d0)/(1.d0 + 650.d0*E**(2.3d0) + 1500.d0*E**(4.2d0)) 



end function  phiepbkg


function phiebkg(E)

 implicit none

 real (8) :: phiebkg, E


! Fluxes of prim and sec of e- in GeV^-1 cm^-2 s^-1 sr^-1
 phiebkg = 0.16d0 * E**(-1.1d0)/(1.d0 + 11.d0*E**(0.9d0) + 3.2d0*E**(2.15d0)) &
       + 0.7d0 * E**(0.7d0)/( 1.d0 + 110.d0*E**(1.5d0) + 600.d0*E**(2.9d0) + 580.d0*E**(4.2d0))



end function  phiebkg



  
