*****************************************************************************
*** function dsmudydth is the differential yield dyield/dtheta which
*** should be integrated (by the routine gadap).
*** units: 1.0e-15 m**-2 (annihilation)**-1
*****************************************************************************

      real*8 function dsmudydth(th)
      implicit none
      include 'dsmucom.h'

c------------------------ variables ------------------------------------

      real*8 th
      real*8 e1cm,e1
      integer istat
      character*2 wh

c------------------------ functions ------------------------------------
      real*8 dsmuyieldf
c-----------------------------------------------------------------------

      if (phiwh.eq.1) then
        wh='su'
      else
        wh='ea'
      endif
c...calculate the energy of particle 1 in the lab system

      e1cm=(phim0**2+phim1**2-phim2**2)/(2.0*phim0)
      e1=phie0/phim0*(e1cm + sqrt(phie0**2-phim0**2)/phie0*
     +  sqrt(e1cm**2-phim1**2)*cos(th))
      dsmudydth=1.0d+15*1.0d0/4.0d0*
     &  dsmuyieldf(e1,phieth,phithm,phich,wh,phifk,phifv,istat)*sin(th)
      end











