*****************************************************************************
***   subroutine dsprep calculates different frequently used cross
***   sections, annihilation branching ratios and sets different common
***   block variable when a new model has been defined. this routine
***   hasto be called before the relic density or any rates are
***   calculated and is called from dssusy.
***   
*** author: joakim edsjo  edsjo@physics.berkeley.edu
*** date: 98-02-27
*** modified: 99-02-23 pg, 00-08-09 je
*****************************************************************************

      subroutine dsprep
      implicit none
      include 'dssusy.h'
      include 'dsprep.h'
      include 'dsidtag.h'


c------------------------ functions ------------------------------------

      real*8 dsandwdcosnn

c------------------------ variables ------------------------------------

      integer i,j,kh(4)

c----------------------------------------------- set-up common variables

c...flags for subroutines. with the help of these flags, some cpu
c...consuming calculations are only done once per model.
      newmodelanwx=.true.
      newmodelandwdcosnn=.true.
      newmodelep=.true.
      newmodelntdk=.true.
      newmodelsigmav=.true.
      dsprepcalled=.true.


c...Set up Higgses
      kh(1)=kh1
      kh(2)=kh2
      kh(3)=kh3
      kh(4)=khc
      mh(1)=mass(kh1)
      mh(2)=mass(kh2)
      mh(3)=mass(kh3)
      mh(4)=mass(khc)


c...Note: the sigma v setup is now moved to dssigmav

c...Note, the channels from Hdecay (16-19) are not yet used.
      do i=1,15
        do j=1,4
          hdw(i,j)=hdwidth(i,j)/width(kh(j))
c            write(*,*) 'hdw(',i,',',j,') = ',hdw(i,j)
        enddo
      enddo


      end
