      subroutine dsspectrum(unphys,hwarning)
c_______________________________________________________________________
c  particle spectrum and mixing matrices
c  common:
c    'dssusy.h' - file with susy common blocks
c  uses sconst, sfesct, chasct, higsct, neusct
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994-1999
c  this has been changed completly to accomodate softsusy spectrum
c  by Roberto Ruiz
c=======================================================================
      implicit none
      include 'dssusy.h'
      include'dssoftsusy.h'
      integer i,j,unphys,hwarning
      real*8 zgm,dsabsq
      character*80 message

      integer g,e1,e2
      real*8 stL, ctL, stR, ctR


c----------------------------------------------------------- gluino mass

      mass(kgluin) = abs(m3)

c------------------------------------------- sfermion masses and mixings


      do g=1,3
        mass(ksqu(g)) =  msu(g,1)
        mass(ksqu(g+3)) =  msu(g,2)
        mass(ksqd(g)) =  msd(g,1)
        mass(ksqd(g+3)) =  msd(g,2)
        mass(ksl(g)) = mse(g,1)
        mass(ksl(g+3)) = mse(g,2)
        mass(ksnu(g))= msnu(g)
      enddo



      do g=1,3
        do i=1,3
          slulmx(i,g) = dcmplx(0.d0,0.d0)
        enddo
        do i=1,6
          sldlmx(i,g) = dcmplx(0.d0,0.d0)
          sldrmx(i,g) = dcmplx(0.d0,0.d0)
          squlmx(i,g) = dcmplx(0.d0,0.d0)
          squrmx(i,g) = dcmplx(0.d0,0.d0)
          sqdlmx(i,g) = dcmplx(0.d0,0.d0)
          sqdrmx(i,g) = dcmplx(0.d0,0.d0)
        enddo
        slulmx(g,g) = dcmplx(1.d0,0.d0)
        sldlmx(g,g) = dcmplx(1.d0,0.d0)
        sldrmx(g+3,g) = dcmplx(1.d0,0.d0)
        squlmx(g,g) = dcmplx(1.d0,0.d0)
        squrmx(g+3,g) = dcmplx(1.d0,0.d0)
        sqdlmx(g,g) = dcmplx(1.d0,0.d0)
        sqdrmx(g+3,g) = dcmplx(1.d0,0.d0)
      enddo


      squlmx(3,3)= dcmplx(cos(thetat),0.d0)
      squlmx(6,3) = dcmplx(-sin(thetat),0.d0)
      squrmx(3,3) = dcmplx(sin(thetat),0.d0)
      squrmx(6,3) = dcmplx(cos(thetat),0.d0)

      sqdlmx(3,3)= dcmplx(cos(thetab),0.d0)
      sqdlmx(6,3) = dcmplx(-sin(thetab),0.d0)
      sqdrmx(3,3) = dcmplx(sin(thetab),0.d0)
      sqdrmx(6,3) = dcmplx(cos(thetab),0.d0)


      sldlmx(3,3)= dcmplx(cos(thetatau),0.d0)
      sldlmx(6,3) = dcmplx(-sin(thetatau),0.d0)
      sldrmx(3,3) = dcmplx(sin(thetatau),0.d0)
      sldrmx(6,3) = dcmplx(cos(thetatau),0.d0)


c------------------------------------------ neutralino masses and mixing


      do i=1,4
       do j=1,4
        mass(kn(i)) = abs(mchi(i))
        if (mchi(i).ge.0.d0) then
         neunmx(i,j) = dcmplx(mixchi(i,j),0.d0)
        else
         neunmx(i,j) =  dcmplx(0.d0,mixchi(i,j))
        endif
       enddo      
      enddo

c

      kln = 1

c------------------------------------------- chargino masses and mixings


      mass(kcha(1)) = abs(mcha(2))
      mass(kcha(2)) = abs(mcha(1))


      ctL=cos(thetaL + PI * 0.5)
      stL=sin(thetaL + PI * 0.5)

      ctR=cos(thetaR + PI * 0.5)
      stR=sin(thetaR + PI * 0.5)


      chaumx(1,1)=dcmplx(ctL,0.d0)
      chaumx(1,2)=dcmplx(stL,0.d0)
      chaumx(2,1)=dcmplx(-stL,0.d0)
      chaumx(2,2)=dcmplx(ctL,0.d0) 

      if(mcha(2).lt.0.0) then
         e1=-1
      else
         e1=1
      endif
      if(mcha(1).lt.0.0) then
        e2=-1
      else
        e2=1
      endif

      chavmx(1,1)=dcmplx(e1*ctR,0.d0)
      chavmx(1,2)=dcmplx(e1*stR,0.d0)
      chavmx(2,1)=dcmplx(-e2*stR,0.d0)
      chavmx(2,2)=dcmplx(e2*ctR,0.d0) 
 


c---------------------------------------- higgs boson masses and mixings
c now from SoftSusy ---------------

       hwarning = 0

c-------------------------------------- lightest supersymmetric particle

      lsp = kn(kln)
      do i=21,48
         if (abs(mass(i)).lt.abs(mass(lsp))) lsp = i
      enddo
      if (lsp.lt.42.or.lsp.gt.45) then
         unphys=1
         write (message,*)
     &        'lsp is ',pname(lsp),
     &        ' m_lsp=',real(mass(lsp)),
     &        ' (m_x0=',real(mass(kn(kln))),')'
         call dswrite(1,1,message)
      endif
      zg = dsabsq(neunmx(1,1))+dsabsq(neunmx(1,2))
      zgm = dsabsq(neunmx(1,3))+dsabsq(neunmx(1,4))
      lgzg = log10(zg)-log10(zgm)



      end
