* hggSM.F
* the Higgs -> gluon gluon main program 
* this file is part of FeynHiggs
* last modified 28 Feb 06 th

#include "externals.h"

#define IDENTICALFACTOR .5D0


	subroutine hggSM(n, res)
	implicit none
	integer n
	double precision res

#include "Decay.h"

	double precision sqrtS, Pout
	integer nflavours

	double precision AlfasMH
	external AlfasMH

	hno = n
	sqrtS = MHiggs(hno)
	Pout = .5D0*sqrtS

* leading correction factors in O(alpha_s)
	nflavours = 6
	if( sqrtS .lt. MT ) nflavours = 5
	als = AlfasMH(sqrtS)
	QCDh = 1 + als/pi*(95/4D0 - 7/6D0*nflavours)

* Higgs
	call VecSet(1, sqrtS, 0D0, 0D0, 0D0, 1D0)

* gluon
	call VecSet(2, 0D0, Pout, 1D0, 0D0, 0D0)

* gluon
	call VecSet(3, 0D0, Pout, -1D0, 0D0, 0D0)

	call hggSM_SquaredME(res)

* throw in 4 pi from the integration, symmetry factors, and flux
	res = 4*pi*(IDENTICALFACTOR)*
     &    1/(2*(2*pi)**2*4)*Pout/sqrtS**2*
     &    QCDh*res
	end

