* FHMode.h
* the data structures for FHMode.F
* this file is part of FeynHiggs
* last modified 15 Nov 06 th


	double precision invalid, default
	parameter (invalid = -999)
	parameter (default = -888)

	double complex cI
	parameter (cI = (0D0, 1D0))

	double precision GF, sqrt2
	parameter (GF = 1.16639D-5)
	parameter (sqrt2 = 1.41421356237309504880168872421D0)

	integer AlfasMZ, MC, MT, MB, MW, MZ, TB, MA0, MHp
	integer MSusy, M1SL, M2SL, M3SL, M1SE, M2SE, M3SE
	integer M1SQ, M2SQ, M3SQ, M1SU, M2SU, M3SU, M1SD, M2SD, M3SD
	integer Qtau, Qt, Qb
	integer CKMtheta12, CKMtheta23, CKMtheta13, CKMdelta13

	parameter (AlfasMZ = 1)
	parameter (MC = AlfasMZ + 1)
	parameter (MT = MC + 1)
	parameter (MB = MT + 1)
	parameter (MW = MB + 1)
	parameter (MZ = MW + 1)
	parameter (TB = MZ + 1)
	parameter (MA0 = TB + 1)
	parameter (MHp = MA0 + 1)
	parameter (MSusy = MHp + 1)
	parameter (M1SL = MSusy + 1)
	parameter (M2SL = M1SL + 1)
	parameter (M3SL = M2SL + 1)
	parameter (M1SE = M3SL + 1)
	parameter (M2SE = M1SE + 1)
	parameter (M3SE = M2SE + 1)
	parameter (M1SQ = M3SE + 1)
	parameter (M2SQ = M1SQ + 1)
	parameter (M3SQ = M2SQ + 1)
	parameter (M1SU = M3SQ + 1)
	parameter (M2SU = M1SU + 1)
	parameter (M3SU = M2SU + 1)
	parameter (M1SD = M3SU + 1)
	parameter (M2SD = M1SD + 1)
	parameter (M3SD = M2SD + 1)
	parameter (Qtau = M3SD + 1)
	parameter (Qt = Qtau + 1)
	parameter (Qb = Qt + 1)
	parameter (CKMtheta12 = Qb + 1)
	parameter (CKMtheta23 = CKMtheta12 + 1)
	parameter (CKMtheta13 = CKMtheta23 + 1)
	parameter (CKMdelta13 = CKMtheta13 + 1)

	integer NReal
	parameter (NReal = CKMdelta13)

	integer Ae, Au, Ad, Amu, Ac, As, Atau, At, Ab, Xt
	integer MUE, M_1, M_2, M_3
	integer deltaLLuc, deltaLRuc, deltaRLuc, deltaRRuc
	integer deltaLLct, deltaLRct, deltaRLct, deltaRRct
	integer deltaLLut, deltaLRut, deltaRLut, deltaRRut
	integer deltaLLds, deltaLRds, deltaRLds, deltaRRds
	integer deltaLLsb, deltaLRsb, deltaRLsb, deltaRRsb
	integer deltaLLdb, deltaLRdb, deltaRLdb, deltaRRdb
	parameter (Ae = 1)
	parameter (Au = Ae + 1)
	parameter (Ad = Au + 1)
	parameter (Amu = Ad + 1)
	parameter (Ac = Amu + 1)
	parameter (As = Ac + 1)
	parameter (Atau = As + 1)
	parameter (At = Atau + 1)
	parameter (Ab = At + 1)
	parameter (Xt = Ab + 1)
	parameter (MUE = Xt + 1)
	parameter (M_1 = MUE + 1)
	parameter (M_2 = M_1 + 1)
	parameter (M_3 = M_2 + 1)
	parameter (deltaLLuc = M_3 + 1)
	parameter (deltaLRuc = deltaLLuc + 1)
	parameter (deltaRLuc = deltaLRuc + 1)
	parameter (deltaRRuc = deltaRLuc + 1)
	parameter (deltaLLct = deltaRRuc + 1)
	parameter (deltaLRct = deltaLLct + 1)
	parameter (deltaRLct = deltaLRct + 1)
	parameter (deltaRRct = deltaRLct + 1)
	parameter (deltaLLut = deltaRRct + 1)
	parameter (deltaLRut = deltaLLut + 1)
	parameter (deltaRLut = deltaLRut + 1)
	parameter (deltaRRut = deltaRLut + 1)
	parameter (deltaLLds = deltaRRut + 1)
	parameter (deltaLRds = deltaLLds + 1)
	parameter (deltaRLds = deltaLRds + 1)
	parameter (deltaRRds = deltaRLds + 1)
	parameter (deltaLLsb = deltaRRds + 1)
	parameter (deltaLRsb = deltaLLsb + 1)
	parameter (deltaRLsb = deltaLRsb + 1)
	parameter (deltaRRsb = deltaRLsb + 1)
	parameter (deltaLLdb = deltaRRsb + 1)
	parameter (deltaLRdb = deltaLLdb + 1)
	parameter (deltaRLdb = deltaLRdb + 1)
	parameter (deltaRRdb = deltaRLdb + 1)

	integer NComplex
	parameter (NComplex = deltaRRdb)

	integer NVars
	parameter (NVars = NReal + 4*NComplex)

	double precision lower(NVars), upper(NVars), step(NVars)
	double precision var(NVars)
	logical logscale(NVars)

        common /fe_vars/ lower, upper, step, var, logscale

	double precision rlower(NReal), rvar(NReal)
	equivalence (lower(1), rlower)
	equivalence (var(1), rvar)

	double precision clower(4,NComplex), cvar(4,NComplex)
	double complex dlower(2,NComplex), dvar(2,NComplex)
	equivalence (lower(NReal + 1), clower, dlower)
	equivalence (var(NReal + 1), cvar, dvar)

	character*16 name(NVars), dname(NComplex)

	common /fe_names/ name, dname

	character*16 rname(NReal)
	equivalence (name(1), rname)

	character*16 cname(4,NComplex)
	equivalence (name(NReal + 1), cname)

