* SetFlags.F
* all flags for FeynHiggs are initialized here
* this file is part of FeynHiggs
* last modified 12 Dec 06 th

#include "externals.h"
#include "debug.h"
#include "../version.h"


	block data dataini

#include "FH.h"

	data flags_valid /.FALSE./
	data para_valid  /.FALSE./
	data higgs_valid /.FALSE./
	data coup_valid  /.FALSE./

	data debuglevel  /0/
	data uzint       /1/
	data uzext       /2/

	data Hff /12*1/
	end

************************************************************************

	subroutine FHSetFlags(error, mssmpart_, fieldren_, tanbren_,
     &    higgsmix_, p2approx_, looplevel_,
     &    tl_running_mt_, tl_bot_resum_)
	implicit none
	integer error
	integer mssmpart_, fieldren_, tanbren_
	integer higgsmix_, p2approx_, looplevel_
	integer tl_running_mt_, tl_bot_resum_

#include "FH.h"
#define __SUBROUTINE__ "FHSetFlags"

	character*10 env

	logical blurb
	data blurb /.FALSE./

	if( blurb ) then
	  print *, "-----------------------------------------------------"
	  print *, "FeynHiggs "//FHVERSION
	  print *, "built on "//FHDATE
	  print *, "by S. Heinemeyer, T. Hahn, W. Hollik, and G. Weiglein"
	  print *, "http://www.feynhiggs.de"
	  print *, "-----------------------------------------------------"
	  blurb = .FALSE.
	endif

	flags_valid = .FALSE.
	para_valid = .FALSE.
	higgs_valid = .FALSE.
	coup_valid = .FALSE.

	call getenv("FHDEBUG", env)
	read(env, *, end=9, err=9) debuglevel
	DFLAGS "debug level ", debuglevel ENDL
9	continue

	call getenv("FHSELECTUZ", env)
	read(env, *, end=10, err=10) uzint, uzext
	DFLAGS "uzint, uzext ", uzint, uzext ENDL
10	continue

	error = 0

#define Check(flag, lo, hi, name) \
if(flag.lt.lo .or. flag.gt.hi) Error(name//" invalid")

	Check(mssmpart_,      0, 4, "mssmpart")
	Check(fieldren_,      0, 4, "fieldren")
	Check(tanbren_,       0, 2, "tanbren")
	Check(higgsmix_,      1, 4, "higgsmix")
	Check(p2approx_,      0, 4, "p2approx")
	Check(looplevel_,     0, 2, "looplevel")
	Check(tl_running_mt_, 0, 1, "tl_running_mt")
	Check(tl_bot_resum_,  0, 1, "tl_bot_resum")

	if( mssmpart_ .eq. 0 .and. higgsmix_ .gt. 2 )
     &    Error("mssmpart = 0 with higgsmix > 2 not allowed")

	if( fieldren_ .eq. 4 .and. tanbren_ .eq. 1 )
     &    Error("fieldren = 4 not compatible with tanbren = 1")

	if( error .gt. 0 ) goto 999

	mssmpart = mssmpart_
	fieldren = fieldren_
	tanbren = tanbren_
	higgsmix = higgsmix_
	p2approx = p2approx_
	looplevel = looplevel_
	tl_running_mt = tl_running_mt_
	tl_bot_resum = tl_bot_resum_

	if( mssmpart .eq. 0 ) p2approx = 1

	flags_valid = .TRUE.

999	continue

	if( debuglevel .lt. 1 ) return

	DFLAGS "============================"	ENDL
	DFLAGS "flags set by FHSetFlags"	ENDL
	DFLAGS "----------------------------"	ENDL
	DFLAGS "mssmpart      =", mssmpart	ENDL
	DFLAGS "fieldren      =", fieldren	ENDL
	DFLAGS "tanbren       =", tanbren	ENDL
	DFLAGS "higgsmix      =", higgsmix	ENDL
	DFLAGS "p2approx      =", p2approx	ENDL
	DFLAGS "looplevel     =", looplevel	ENDL
	DFLAGS "tl_running_mt =", tl_running_mt	ENDL
	DFLAGS "tl_bot_resum  =", tl_bot_resum	ENDL
	end

