* SetNMFV.F
* set the non-minimal flavour-violation parameters
* this file is part of FeynHiggs
* last modified 5 Dec 06 th

#include "externals.h"
#include "debug.h"
#include "SLHADefs.h"


	subroutine FHSetNMFV(error,
     &    deltaLLuc_, deltaLRuc_, deltaRLuc_, deltaRRuc_,
     &    deltaLLct_, deltaLRct_, deltaRLct_, deltaRRct_,
     &    deltaLLut_, deltaLRut_, deltaRLut_, deltaRRut_,
     &    deltaLLds_, deltaLRds_, deltaRLds_, deltaRRds_,
     &    deltaLLsb_, deltaLRsb_, deltaRLsb_, deltaRRsb_,
     &    deltaLLdb_, deltaLRdb_, deltaRLdb_, deltaRRdb_)
	implicit none
	integer error
	double complex deltaLLuc_, deltaLRuc_
	double complex deltaRLuc_, deltaRRuc_
	double complex deltaLLct_, deltaLRct_
	double complex deltaRLct_, deltaRRct_
	double complex deltaLLut_, deltaLRut_
	double complex deltaRLut_, deltaRRut_
	double complex deltaLLds_, deltaLRds_
	double complex deltaRLds_, deltaRRds_
	double complex deltaLLsb_, deltaLRsb_
	double complex deltaRLsb_, deltaRRsb_
	double complex deltaLLdb_, deltaLRdb_
	double complex deltaRLdb_, deltaRRdb_

#include "FH.h"
#define __SUBROUTINE__ "FHSetNMFV"

	integer t, g, g2
	double precision MBsave, MB2save, m, m2
	double complex deltaSf(3:4,6,6), MX2(6,6)

	double complex MX2flat(6*6)
	equivalence (MX2, MX2flat)

	double complex deltaSf_flat(2*6*6)
	equivalence (deltaSf, deltaSf_flat)

	error = 0

	if( .not. flags_valid )
     &    Error("must call FHSetFlags before")
	if( .not. para_valid )
     &    Error("must call FHSetPara before")

	if( error .ne. 0 ) return

	if( debuglevel .ge. 2 ) then
	  DPARA "============================"	ENDL
	  DPARA "FHSetNMFV input parameters:"	ENDL
	  DPARA "----------------------------"	ENDL
	  DPARA "deltaLLuc =", deltaLLuc_	ENDL
	  DPARA "     LR   =", deltaLRuc_	ENDL
	  DPARA "     RL   =", deltaRLuc_	ENDL
	  DPARA "     RR   =", deltaRRuc_	ENDL
	  DPARA "deltaLLct =", deltaLLct_	ENDL
	  DPARA "     LR   =", deltaLRct_	ENDL
	  DPARA "     RL   =", deltaRLct_	ENDL
	  DPARA "     RR   =", deltaRRct_	ENDL
	  DPARA "deltaLLut =", deltaLLut_	ENDL
	  DPARA "     LR   =", deltaLRut_	ENDL
	  DPARA "     RL   =", deltaRLut_	ENDL
	  DPARA "     RR   =", deltaRRut_	ENDL
	  DPARA "deltaLLds =", deltaLLds_	ENDL
	  DPARA "     LR   =", deltaLRds_	ENDL
	  DPARA "     RL   =", deltaRLds_	ENDL
	  DPARA "     RR   =", deltaRRds_	ENDL
	  DPARA "deltaLLsb =", deltaLLsb_	ENDL
	  DPARA "     LR   =", deltaLRsb_	ENDL
	  DPARA "     RL   =", deltaRLsb_	ENDL
	  DPARA "     RR   =", deltaRRsb_	ENDL
	  DPARA "deltaLLdb =", deltaLLdb_	ENDL
	  DPARA "     LR   =", deltaLRdb_	ENDL
	  DPARA "     RL   =", deltaRLdb_	ENDL
	  DPARA "     RR   =", deltaRRdb_	ENDL
	endif

	nmfv = 1

	do g = 1, 2*6*6
	  deltaSf_flat(g) = 0
	enddo

	deltaSf(3,1  ,2  ) = deltaLLuc_
	deltaSf(3,1  ,2+3) = deltaLRuc_
	deltaSf(3,2  ,1+3) = DCONJG(deltaRLuc_)
	deltaSf(3,1+3,2+3) = deltaRRuc_

	deltaSf(3,2  ,3  ) = deltaLLct_
	deltaSf(3,2  ,3+3) = deltaLRct_
	deltaSf(3,3  ,2+3) = DCONJG(deltaRLct_)
	deltaSf(3,2+3,3+3) = deltaRRct_

	deltaSf(3,1  ,3  ) = deltaLLut_
	deltaSf(3,1  ,3+3) = deltaLRut_
	deltaSf(3,3  ,1+3) = DCONJG(deltaRLut_)
	deltaSf(3,1+3,3+3) = deltaRRut_

	deltaSf(4,1  ,2  ) = deltaLLds_
	deltaSf(4,1  ,2+3) = deltaLRds_
	deltaSf(4,2  ,1+3) = DCONJG(deltaRLds_)
	deltaSf(4,1+3,2+3) = deltaRRds_

	deltaSf(4,2  ,3  ) = deltaLLsb_
	deltaSf(4,2  ,3+3) = deltaLRsb_
	deltaSf(4,3  ,2+3) = DCONJG(deltaRLsb_)
	deltaSf(4,2+3,3+3) = deltaRRsb_

	deltaSf(4,1  ,3  ) = deltaLLdb_
	deltaSf(4,1  ,3+3) = deltaLRdb_
	deltaSf(4,3  ,1+3) = DCONJG(deltaRLdb_)
	deltaSf(4,1+3,3+3) = deltaRRdb_

	MBsave = MB
	MB2save = MB2
	MB = MBy
	MB2 = MBy2

	do t = 3, 4
	  do g = 1, 6*6
	    MX2flat(g) = 0
	  enddo
	  do g = 1, 3
	    MX2(g,g) = DSS2(1,t,g) + DSS2(2,t,g) + Mf2(t,g)
	    MX2(g+3,g+3) = DSS2(2,t,g) + Mf2(t,g)
	    MX2(g,g+3) = Mf(t,g)*DCONJG(Xf(t,g,g))
	  enddo

#define MX2diag(g) MX2flat(7*(g - ibits(3 - g, 2, 2)) - 6)
* same as: (g > 3) ? MX2(g-3,g-3) : MX2(g,g)

	  do g2 = 6, 1, -1
	    m2 = MX2diag(g2)
	    do g = g2 - 1, 1, -1
	      m = MX2diag(g)
	      MX2(g,g2) = MX2(g,g2) + deltaSf(t,g,g2)*sqrt(m*m2)
	    enddo
	  enddo

	  Af(t,1,2) = MX2(1,2+3)/Mf(t,1)
	  Af(t,2,1) = MX2(2,1+3)/Mf(t,2)
	  Af(t,1,3) = MX2(1,3+3)/Mf(t,1)
	  Af(t,3,1) = MX2(3,1+3)/Mf(t,3)
	  Af(t,2,3) = MX2(2,3+3)/Mf(t,2)
	  Af(t,3,2) = MX2(3,2+3)/Mf(t,3)

	  call NMFVMasses(error, t, MX2)
	enddo

	MB = MBsave
	MB2 = MB2save
	end

#undef __SUBROUTINE__


************************************************************************

	subroutine SetNMFVSLHA(error, t, MSQ_, MSU_, Af_)
	implicit none
	integer error, t
	double complex MSQ_(3,3), MSU_(3,3), Af_(3,3)

#include "FH.h"

	integer g, g2
	double complex MX2(6,6)

	nmfv = 1

	do g = 1, 3
	  do g2 = g, 3
	    if( MSQ_(g,g2) .eq. invalid ) then
	      MX2(g,g2) = 0
	    else
	      MX2(g,g2) = MSQ_(g,g2)
	    endif
	  enddo
	  MX2(g,g) = MX2(g,g) + DSf(1,t) + Mf2(t,g)

	  do g2 = g, 3
	    if( MSU_(g,g2) .eq. invalid ) then
	      MX2(g+3,g2+3) = 0
	    else
	      MX2(g+3,g2+3) = MSU_(g,g2)
	    endif
	  enddo
	  MX2(g+3,g+3) = MX2(g+3,g+3) + DSf(2,t) + Mf2(t,g)

	  do g2 = 1, 3
	    if( Af_(g,g2) .eq. invalid ) then
	      MX2(g,g2+3) = 0
	    else
	      MX2(g,g2+3) = Mf(t,g)*DCONJG(Af_(g,g2))
	    endif
	  enddo
	  MX2(g,g+3) = MX2(g,g+3) - Mf(t,g)*DCONJG(MUETB(t))
	enddo

	call NMFVMasses(error, t, MX2)
	end


************************************************************************

	subroutine NMFVMasses(error, t, MX2)
	implicit none
	integer error, t
	double complex MX2(6,6)

#include "FH.h"
#define __SUBROUTINE__ "NMFVMasses"

	integer as1

	if( debuglevel .ge. 3 ) then
	  DPARA "========================"	ENDL
	  DPARA "LL MX2(1,1) =", MX2(1,1)	ENDL
	  DPARA "   MX2(1,2) =", MX2(1,2)	ENDL
	  DPARA "   MX2(1,3) =", MX2(1,3)	ENDL
	  DPARA "   MX2(2,1) =", MX2(2,1)	ENDL
	  DPARA "   MX2(2,2) =", MX2(2,2)	ENDL
	  DPARA "   MX2(2,3) =", MX2(2,3)	ENDL
	  DPARA "   MX2(3,1) =", MX2(3,1)	ENDL
	  DPARA "   MX2(3,2) =", MX2(3,2)	ENDL
	  DPARA "   MX2(3,3) =", MX2(3,3)	ENDL
	  DPARA "------------------------"	ENDL
	  DPARA "LR MX2(1,4) =", MX2(1,4)	ENDL
	  DPARA "   MX2(1,5) =", MX2(1,5)	ENDL
	  DPARA "   MX2(1,6) =", MX2(1,6)	ENDL
	  DPARA "   MX2(2,4) =", MX2(2,4)	ENDL
	  DPARA "   MX2(2,5) =", MX2(2,5)	ENDL
	  DPARA "   MX2(2,6) =", MX2(2,6)	ENDL
	  DPARA "   MX2(3,4) =", MX2(3,4)	ENDL
	  DPARA "   MX2(3,5) =", MX2(3,5)	ENDL
	  DPARA "   MX2(3,6) =", MX2(3,6)	ENDL
	  DPARA "------------------------"	ENDL
	  DPARA "RL MX2(4,1) =", MX2(4,1)	ENDL
	  DPARA "   MX2(4,2) =", MX2(4,2)	ENDL
	  DPARA "   MX2(4,3) =", MX2(4,3)	ENDL
	  DPARA "   MX2(5,1) =", MX2(5,1)	ENDL
	  DPARA "   MX2(5,2) =", MX2(5,2)	ENDL
	  DPARA "   MX2(5,3) =", MX2(5,3)	ENDL
	  DPARA "   MX2(6,1) =", MX2(6,1)	ENDL
	  DPARA "   MX2(6,2) =", MX2(6,2)	ENDL
	  DPARA "   MX2(6,3) =", MX2(6,3)	ENDL
	  DPARA "------------------------"	ENDL
	  DPARA "RR MX2(4,4) =", MX2(4,4)	ENDL
	  DPARA "   MX2(4,5) =", MX2(4,5)	ENDL
	  DPARA "   MX2(4,6) =", MX2(4,6)	ENDL
	  DPARA "   MX2(5,4) =", MX2(5,4)	ENDL
	  DPARA "   MX2(5,5) =", MX2(5,5)	ENDL
	  DPARA "   MX2(5,6) =", MX2(5,6)	ENDL
	  DPARA "   MX2(6,4) =", MX2(6,4)	ENDL
	  DPARA "   MX2(6,5) =", MX2(6,5)	ENDL
	  DPARA "   MX2(6,6) =", MX2(6,6)	ENDL
        endif

	call HEigensystem(6, MX2,6, MASf2(1,t), UASf(1,1,t),6, 1)

	if( MASf2(1,t) .lt. 0 ) then
	  Error("Negative MASf2")
	  return
	endif

	do as1 = 1, 6
	  MASf(as1,t) = sqrt(MASf2(as1,t))
	enddo

	if( debuglevel .lt. 1 ) return

	DPARA "============================"	ENDL
	DPARA "parameters set by NMFVMasses"	ENDL
	DPARA "----------------------------"	ENDL
	DPARA "MASf("//Digit(t)//") =", MASf(1,t), MASf(2,t) ENDL
	DPARA "         ", MASf(3,t), MASf(4,t) ENDL
	DPARA "         ", MASf(5,t), MASf(6,t) ENDL
	end

