* dse_G0G0.F
* this file is part of FeynHiggs
* generated 07 Nov 2006 18:06

#include "externals.h"


	double complex function dse_G0G0(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex dse_G0G0_mfv, dse_G0G0_nmfv
	external dse_G0G0_mfv, dse_G0G0_nmfv

	if( nmfv .eq. 0 ) then
	  dse_G0G0 = dse_G0G0_mfv(k2)
	else
	  dse_G0G0 = dse_G0G0_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'dse_G0G0 =', dse_G0G0
#endif
	end


************************************************************************


	double complex function dse_G0G0_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Cha2, Gen1, Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	dse_G0G0_mfv = 0

	do Gen1 = g, 3
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)) + 
     -         k2*DB1(k2,Mf2(3,Gen1),Mf2(3,Gen1)))*Mf2(3,Gen1))/
     -     (MW2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
	tmp1 = TB*Af(3,Gen1,Gen1) - DCONJG(MUE)
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,3,Gen1))*Mf2(3,Gen1)*
     -       (tmp1*USf(Sfe2,2,3,Gen1)*USfC(Sfe1,1,3,Gen1) + 
     -         (MUE - TB*DCONJG(Af(3,Gen1,Gen1)))*
     -          USf(Sfe2,1,3,Gen1)*USfC(Sfe1,2,3,Gen1))*
     -       (tmp1*USf(Sfe1,2,3,Gen1)*USfC(Sfe2,1,3,Gen1) + 
     -         (MUE - TB*DCONJG(Af(3,Gen1,Gen1)))*
     -          USf(Sfe1,1,3,Gen1)*USfC(Sfe2,2,3,Gen1)))/
     -     (MW2*SW2*TB2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_mfv =', dse_G0G0_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(4,Gen1),Mf2(4,Gen1)) + 
     -         k2*DB1(k2,Mf2(4,Gen1),Mf2(4,Gen1)))*Mdy2(Gen1,1))/
     -     (MW2*SW2)
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
	tmp2 = MUE*TB - DCONJG(Af(4,Gen1,Gen1))
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe1,4,Gen1),
     -        MSf2(Sfe2,4,Gen1))*Mdy2(Gen1,1)*
     -       ((Af(4,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe2,2,4,Gen1)*USfC(Sfe1,1,4,Gen1) + 
     -         tmp2*USf(Sfe2,1,4,Gen1)*USfC(Sfe1,2,4,Gen1))*
     -       ((Af(4,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe1,2,4,Gen1)*USfC(Sfe2,1,4,Gen1) + 
     -         tmp2*USf(Sfe1,1,4,Gen1)*USfC(Sfe2,2,4,Gen1)))/
     -     (MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_mfv =', dse_G0G0_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -         k2*DB1(k2,Mf2(2,Gen1),Mf2(2,Gen1)))*Mf2(2,Gen1))/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
	tmp3 = MUE*TB - DCONJG(Af(2,Gen1,Gen1))
        dse_G0G0_mfv = dse_G0G0_mfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*Mf2(2,Gen1)*
     -       ((Af(2,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe2,2,2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -         tmp3*USf(Sfe2,1,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((Af(2,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe1,2,2,Gen1)*USfC(Sfe2,1,2,Gen1) + 
     -         tmp3*USf(Sfe1,1,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_mfv =', dse_G0G0_mfv
#endif

	if( mssmpart .eq. 3 ) return

        dse_G0G0_mfv = dse_G0G0_mfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B**2*MW2*SAB**2 + 
     -          CW2*(-(k2*SBA**2) - Mh02*SBA**2))*DB0(k2,Mh02,MZ2)+
     -         Alfa*(MW2*S2B**2*
     -           (SAB**2*DB0(k2,MA02,Mh02) + 
     -             CAB**2*DB0(k2,MA02,MHH2)) - 
     -          (CBA**2*CW2*(k2 + MHH2) - C2B**2*CAB**2*MW2)*
     -           DB0(k2,MHH2,MZ2) + 
     -          CW2*(-(SBA**2*B0(k2,Mh02,MZ2)) + 
     -             2*SBA**2*B1(k2,Mh02,MZ2) - 
     -             2*CW2*(B0(k2,MW2,MW2) - 2*B1(k2,MW2,MW2) + 
     -                k2*DB0(k2,MW2,MW2)) + 
     -             2*k2*SBA**2*DB1(k2,Mh02,MZ2) - 
     -             CBA**2*(B0(k2,MHH2,MZ2) - 
     -                2*(B1(k2,MHH2,MZ2) + k2*DB1(k2,MHH2,MZ2))) + 
     -             4*CW2*k2*DB1(k2,MW2,MW2))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp4 = -(CB*UCha(Cha2,2)*VCha(Cha1,1)) + 
     -   SB*UCha(Cha2,1)*VCha(Cha1,2)
        tmp5 = -(CB*UCha(Cha1,2)*VCha(Cha2,1)) + 
     -   SB*UCha(Cha1,1)*VCha(Cha2,2)
        tmp6 = CB*UChaC(Cha2,2)*VChaC(Cha1,1) - 
     -   SB*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp7 = CB*UChaC(Cha1,2)*VChaC(Cha2,1) - 
     -   SB*UChaC(Cha1,1)*VChaC(Cha2,2)
        dse_G0G0_mfv = dse_G0G0_mfv + 
     -   1/(4.D0*Pi)*(Alfa*(tmp4*tmp6 + tmp5*tmp7)*
     -        (B1(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -          k2*DB1(k2,MCha2(Cha1),MCha2(Cha2))) + 
     -       Alfa*DB0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp6*tmp7*MCha(Cha1)*MCha(Cha2) + 
     -          tmp4*tmp6*MCha2(Cha1) + tmp5*tmp7*MCha2(Cha1) + 
     -          MCha(Cha1)*MCha(Cha2)*
     -           (CB*UCha(Cha2,2)*VCha(Cha1,1) - 
     -             SB*UCha(Cha2,1)*VCha(Cha1,2))*
     -           (CB*UCha(Cha1,2)*VCha(Cha2,1) - 
     -             SB*UCha(Cha1,1)*VCha(Cha2,2))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp8 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp9 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp10 = CB*ZNeu(Neu2,3) + SB*ZNeu(Neu2,4)
	tmp11 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp12 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp13 = CB*ZNeuC(Neu2,3) + SB*ZNeuC(Neu2,4)
        dse_G0G0_mfv = dse_G0G0_mfv + 
     -   1/(16.D0*Pi)*(-2*Alfa*
     -        (B1(k2,MNeu2(Neu1),MNeu2(Neu2)) + 
     -          k2*DB1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -        (tmp10*tmp8 + CB*tmp9*ZNeu(Neu1,3) + 
     -          SB*tmp9*ZNeu(Neu1,4))*
     -        (tmp11*tmp13 + CB*tmp12*ZNeuC(Neu1,3) + 
     -          SB*tmp12*ZNeuC(Neu1,4)) + 
     -       Alfa*DB0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -        (MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp10*tmp8 + CB*tmp9*ZNeu(Neu1,3) + 
     -              SB*tmp9*ZNeu(Neu1,4))**2 - 
     -          2*MNeu2(Neu1)*
     -           (tmp10*tmp8 + CB*tmp9*ZNeu(Neu1,3) + 
     -             SB*tmp9*ZNeu(Neu1,4))*
     -           (tmp11*tmp13 + CB*tmp12*ZNeuC(Neu1,3) + 
     -             SB*tmp12*ZNeuC(Neu1,4)) + 
     -          MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp11*tmp13 + CB*tmp12*ZNeuC(Neu1,3) + 
     -              SB*tmp12*ZNeuC(Neu1,4))**2))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_mfv =', dse_G0G0_mfv
#endif

	end


************************************************************************


	double complex function dse_G0G0_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Cha2, Gen1, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Neu2, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	dse_G0G0_nmfv = 0

	do Gen1 = g, 3
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(3,Gen1),Mf2(3,Gen1)) + 
     -         k2*DB1(k2,Mf2(3,Gen1),Mf2(3,Gen1)))*Mf2(3,Gen1))/
     -     (MW2*SW2)
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All1,3),MASf2(All2,3))*
     -       ((TB*Af(3,Ind1,Ind2) - DCONJG(MUE)*Delta(Ind1,Ind2))*
     -          Mf(3,Ind1)*UASf(All2,3 + Ind2,3)*UASfC(All1,Ind1,3)
     -           + (MUE*Delta(Ind1,Ind2)*Mf(3,Ind1) - 
     -            TB*DCONJG(Af(3,Ind2,Ind1))*Mf(3,Ind2))*
     -          UASf(All2,Ind2,3)*UASfC(All1,3 + Ind1,3))*
     -       ((TB*Af(3,Ind3,Ind4) - DCONJG(MUE)*Delta(Ind3,Ind4))*
     -          Mf(3,Ind3)*UASf(All1,3 + Ind4,3)*UASfC(All2,Ind3,3)
     -           + (MUE*Delta(Ind3,Ind4)*Mf(3,Ind3) - 
     -            TB*DCONJG(Af(3,Ind4,Ind3))*Mf(3,Ind4))*
     -          UASf(All1,Ind4,3)*UASfC(All2,3 + Ind3,3)))/
     -     (MW2*SW2*TB2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_nmfv =', dse_G0G0_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(4,Gen1),Mf2(4,Gen1)) + 
     -         k2*DB1(k2,Mf2(4,Gen1),Mf2(4,Gen1)))*Mdy2(Gen1,1))/
     -     (MW2*SW2)
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   3/(16.D0*Pi)*(Alfa*DB0(k2,MASf2(All1,4),MASf2(All2,4))*
     -       ((Af(4,Ind1,Ind2) - TB*DCONJG(MUE)*Delta(Ind1,Ind2))*
     -          Mdy(Ind1,1)*UASf(All2,3 + Ind2,4)*
     -          UASfC(All1,Ind1,4) + 
     -         (MUE*TB*Delta(Ind1,Ind2)*Mdy(Ind1,1) - 
     -            DCONJG(Af(4,Ind2,Ind1))*Mdy(Ind2,1))*
     -          UASf(All2,Ind2,4)*UASfC(All1,3 + Ind1,4))*
     -       ((Af(4,Ind3,Ind4) - TB*DCONJG(MUE)*Delta(Ind3,Ind4))*
     -          Mdy(Ind3,1)*UASf(All1,3 + Ind4,4)*
     -          UASfC(All2,Ind3,4) + 
     -         (MUE*TB*Delta(Ind3,Ind4)*Mdy(Ind3,1) - 
     -            DCONJG(Af(4,Ind4,Ind3))*Mdy(Ind4,1))*
     -          UASf(All1,Ind4,4)*UASfC(All2,3 + Ind3,4)))/
     -     (MW2*SW2)
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_nmfv =', dse_G0G0_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   1/(4.D0*Pi)*(Alfa*(B1(k2,Mf2(2,Gen1),Mf2(2,Gen1)) + 
     -         k2*DB1(k2,Mf2(2,Gen1),Mf2(2,Gen1)))*Mf2(2,Gen1))/
     -     (MW2*SW2)
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
	tmp1 = MUE*TB - DCONJG(Af(2,Gen1,Gen1))
        dse_G0G0_nmfv = dse_G0G0_nmfv - 
     -   1/(16.D0*Pi)*(Alfa*DB0(k2,MSf2(Sfe1,2,Gen1),
     -        MSf2(Sfe2,2,Gen1))*Mf2(2,Gen1)*
     -       ((Af(2,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe2,2,2,Gen1)*USfC(Sfe1,1,2,Gen1) + 
     -         tmp1*USf(Sfe2,1,2,Gen1)*USfC(Sfe1,2,2,Gen1))*
     -       ((Af(2,Gen1,Gen1) - TB*DCONJG(MUE))*
     -          USf(Sfe1,2,2,Gen1)*USfC(Sfe2,1,2,Gen1) + 
     -         tmp1*USf(Sfe1,1,2,Gen1)*USfC(Sfe2,2,2,Gen1)))/
     -     (MW2*SW2)
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_nmfv =', dse_G0G0_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        dse_G0G0_nmfv = dse_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*(C2B**2*MW2*SAB**2 + 
     -          CW2*(-(k2*SBA**2) - Mh02*SBA**2))*DB0(k2,Mh02,MZ2)+
     -         Alfa*(MW2*S2B**2*
     -           (SAB**2*DB0(k2,MA02,Mh02) + 
     -             CAB**2*DB0(k2,MA02,MHH2)) - 
     -          (CBA**2*CW2*(k2 + MHH2) - C2B**2*CAB**2*MW2)*
     -           DB0(k2,MHH2,MZ2) + 
     -          CW2*(-(SBA**2*B0(k2,Mh02,MZ2)) + 
     -             2*SBA**2*B1(k2,Mh02,MZ2) - 
     -             2*CW2*(B0(k2,MW2,MW2) - 2*B1(k2,MW2,MW2) + 
     -                k2*DB0(k2,MW2,MW2)) + 
     -             2*k2*SBA**2*DB1(k2,Mh02,MZ2) - 
     -             CBA**2*(B0(k2,MHH2,MZ2) - 
     -                2*(B1(k2,MHH2,MZ2) + k2*DB1(k2,MHH2,MZ2))) + 
     -             4*CW2*k2*DB1(k2,MW2,MW2))))/(CW2**2*SW2)

	do Cha1 = 1, 2
	do Cha2 = 1, 2
        tmp2 = -(CB*UCha(Cha2,2)*VCha(Cha1,1)) + 
     -   SB*UCha(Cha2,1)*VCha(Cha1,2)
        tmp3 = -(CB*UCha(Cha1,2)*VCha(Cha2,1)) + 
     -   SB*UCha(Cha1,1)*VCha(Cha2,2)
        tmp4 = CB*UChaC(Cha2,2)*VChaC(Cha1,1) - 
     -   SB*UChaC(Cha2,1)*VChaC(Cha1,2)
        tmp5 = CB*UChaC(Cha1,2)*VChaC(Cha2,1) - 
     -   SB*UChaC(Cha1,1)*VChaC(Cha2,2)
        dse_G0G0_nmfv = dse_G0G0_nmfv + 
     -   1/(4.D0*Pi)*(Alfa*(tmp2*tmp4 + tmp3*tmp5)*
     -        (B1(k2,MCha2(Cha1),MCha2(Cha2)) + 
     -          k2*DB1(k2,MCha2(Cha1),MCha2(Cha2))) + 
     -       Alfa*DB0(k2,MCha2(Cha1),MCha2(Cha2))*
     -        (tmp4*tmp5*MCha(Cha1)*MCha(Cha2) + 
     -          tmp2*tmp4*MCha2(Cha1) + tmp3*tmp5*MCha2(Cha1) + 
     -          MCha(Cha1)*MCha(Cha2)*
     -           (CB*UCha(Cha2,2)*VCha(Cha1,1) - 
     -             SB*UCha(Cha2,1)*VCha(Cha1,2))*
     -           (CB*UCha(Cha1,2)*VCha(Cha2,1) - 
     -             SB*UCha(Cha1,1)*VCha(Cha2,2))))/SW2
	enddo
	enddo

	do Neu1 = 1, 4
	do Neu2 = 1, 4
	tmp6 = SW*ZNeu(Neu1,1) - CW*ZNeu(Neu1,2)
	tmp7 = SW*ZNeu(Neu2,1) - CW*ZNeu(Neu2,2)
	tmp8 = CB*ZNeu(Neu2,3) + SB*ZNeu(Neu2,4)
	tmp9 = SW*ZNeuC(Neu1,1) - CW*ZNeuC(Neu1,2)
	tmp10 = SW*ZNeuC(Neu2,1) - CW*ZNeuC(Neu2,2)
	tmp11 = CB*ZNeuC(Neu2,3) + SB*ZNeuC(Neu2,4)
        dse_G0G0_nmfv = dse_G0G0_nmfv + 
     -   1/(16.D0*Pi)*(-2*Alfa*
     -        (B1(k2,MNeu2(Neu1),MNeu2(Neu2)) + 
     -          k2*DB1(k2,MNeu2(Neu1),MNeu2(Neu2)))*
     -        (tmp6*tmp8 + CB*tmp7*ZNeu(Neu1,3) + 
     -          SB*tmp7*ZNeu(Neu1,4))*
     -        (tmp11*tmp9 + CB*tmp10*ZNeuC(Neu1,3) + 
     -          SB*tmp10*ZNeuC(Neu1,4)) + 
     -       Alfa*DB0(k2,MNeu2(Neu1),MNeu2(Neu2))*
     -        (MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp6*tmp8 + CB*tmp7*ZNeu(Neu1,3) + 
     -              SB*tmp7*ZNeu(Neu1,4))**2 - 
     -          2*MNeu2(Neu1)*
     -           (tmp6*tmp8 + CB*tmp7*ZNeu(Neu1,3) + 
     -             SB*tmp7*ZNeu(Neu1,4))*
     -           (tmp11*tmp9 + CB*tmp10*ZNeuC(Neu1,3) + 
     -             SB*tmp10*ZNeuC(Neu1,4)) + 
     -          MNeu(Neu1)*MNeu(Neu2)*
     -           (tmp11*tmp9 + CB*tmp10*ZNeuC(Neu1,3) + 
     -              SB*tmp10*ZNeuC(Neu1,4))**2))/(CW2*SW2)
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'dse_G0G0_nmfv =', dse_G0G0_nmfv
#endif

	end

