* se_WW.F
* this file is part of FeynHiggs
* generated 07 Nov 2006 18:06

#include "externals.h"


	double complex function se_WW(k2)
	implicit none
	double precision k2

#include "FH.h"

	double complex se_WW_mfv, se_WW_nmfv
	external se_WW_mfv, se_WW_nmfv

	if( nmfv .eq. 0 ) then
	  se_WW = se_WW_mfv(k2)
	else
	  se_WW = se_WW_nmfv(k2)
	endif

#ifdef DEBUG
	print *, 'k2 =', k2
	print *, 'se_WW =', se_WW
#endif
	end


************************************************************************


	double complex function se_WW_mfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer Cha1, Gen1, Gen2, Neu1, Sfe1, Sfe2, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_WW_mfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_WW_mfv =', se_WW_mfv
#endif

	if( mssmpart .eq. 1 ) return


	do Gen1 = g, 3
	do Gen2 = g, 3
        se_WW_mfv = se_WW_mfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (A0(Mf2(4,Gen2)) - 
     -         2*B00(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)))/SW2
	enddo
	enddo

	do Gen1 = g, 3
	do Sfe1 = 1, 2
        se_WW_mfv = se_WW_mfv + 
     -   3/(8.D0*Pi)*(Alfa*(A0(MSf2(Sfe1,3,Gen1))*USf(Sfe1,1,3,Gen1)*
     -          USfC(Sfe1,1,3,Gen1) + 
     -         A0(MSf2(Sfe1,4,Gen1))*USf(Sfe1,1,4,Gen1)*
     -          USfC(Sfe1,1,4,Gen1)))/SW2
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
	do Sfe1 = 1, 2
	do Sfe2 = 1, 2
        se_WW_mfv = se_WW_mfv - 
     -   3/(2.D0*Pi)*(Alfa*B00(k2,MSf2(Sfe1,3,Gen1),
     -        MSf2(Sfe2,4,Gen2))*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       USf(Sfe1,1,3,Gen1)*USf(Sfe2,1,4,Gen2)*
     -       USfC(Sfe1,1,3,Gen1)*USfC(Sfe2,1,4,Gen2))/SW2
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_mfv =', se_WW_mfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_WW_mfv = se_WW_mfv + 
     -   1/(8.D0*Pi)*(Alfa*(-2*A0(Mf2(2,Gen1)) + 
     -         A0(MSf2(1,1,Gen1)) + 4*B00(k2,0.D0,Mf2(2,Gen1)) - 
     -         2*k2*B1(k2,0.D0,Mf2(2,Gen1))))/SW2
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_WW_mfv = se_WW_mfv + 
     -   1/(8.D0*Pi)*(Alfa*(A0(MSf2(Sfe1,2,Gen1)) - 
     -         4*B00(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1)))*
     -       USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_mfv =', se_WW_mfv
#endif

	if( mssmpart .eq. 3 ) return

        se_WW_mfv = se_WW_mfv + 
     -   1/(16.D0*Pi)*(Alfa*CW2*A0(MA02) + Alfa*CW2*A0(Mh02) + 
     -       Alfa*CW2*A0(MHH2) + 2*Alfa*CW2*A0(MHp2) - 
     -       2*Alfa*CW2*(-7 + 4*CW2 + 4*SW2)*A0(MW2) + 
     -       Alfa*CW2*(1 + 12*CW2)*A0(MZ2) + 
     -       4*Alfa*CW2*(-5*k2 + MW2)*SW2*B0(k2,0.D0,MW2) + 
     -       4*Alfa*CW2*MW2*SBA**2*B0(k2,Mh02,MW2) + 
     -       4*Alfa*CBA**2*CW2*MW2*B0(k2,MHH2,MW2) + 
     -       4*Alfa*(CW2**2*(-5*k2 - 2*MZ2) + MW2*SW2**2)*
     -        B0(k2,MW2,MZ2) - 32*Alfa*CW2*SW2*B00(k2,0.D0,MW2) - 
     -       4*Alfa*CW2*B00(k2,MA02,MHp2) - 
     -       4*Alfa*CBA**2*CW2*B00(k2,Mh02,MHp2) - 
     -       4*Alfa*CW2*SBA**2*B00(k2,Mh02,MW2) - 
     -       4*Alfa*CW2*SBA**2*B00(k2,MHH2,MHp2) - 
     -       4*Alfa*CBA**2*CW2*B00(k2,MHH2,MW2) - 
     -       4*Alfa*CW2*(1 + 8*CW2)*B00(k2,MZ2,MW2) - 
     -       8*Alfa*CW2*k2*SW2*B1(k2,0.D0,MW2) - 
     -       8*Alfa*CW2**2*k2*B1(k2,MZ2,MW2))/(CW2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
        tmp1 = (Sqrt(2.D0)*UChaC(Cha1,1)*ZNeu(Neu1,2) + 
     -     UChaC(Cha1,2)*ZNeu(Neu1,3))/Sqrt(2.D0)
        tmp2 = (Sqrt(2.D0)*VChaC(Cha1,1)*ZNeu(Neu1,2) - 
     -     VChaC(Cha1,2)*ZNeu(Neu1,4))/Sqrt(2.D0)
        tmp3 = (Sqrt(2.D0)*UCha(Cha1,1)*ZNeuC(Neu1,2) + 
     -     UCha(Cha1,2)*ZNeuC(Neu1,3))/Sqrt(2.D0)
        tmp4 = (Sqrt(2.D0)*VCha(Cha1,1)*ZNeuC(Neu1,2) - 
     -     VCha(Cha1,2)*ZNeuC(Neu1,4))/Sqrt(2.D0)
        se_WW_mfv = se_WW_mfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -          (A0(MNeu2(Neu1)) - 
     -            2*B00(k2,MCha2(Cha1),MNeu2(Neu1)) + 
     -            k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(tmp2*tmp4*MCha2(Cha1)) + 
     -          tmp3*tmp4*MCha(Cha1)*MNeu(Neu1) + 
     -          tmp1*(-(tmp3*MCha2(Cha1)) + 
     -             tmp2*MCha(Cha1)*MNeu(Neu1))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_mfv =', se_WW_mfv
#endif

	end


************************************************************************


	double complex function se_WW_nmfv(k2)
	implicit character (a-s,u-z)
	implicit double complex (t)
	double precision k2

#include "FH.h"
#include "looptools.h"

	integer All1, All2, Cha1, Gen1, Gen2, Ind1, Ind2, Ind3, Ind4
	integer Neu1, Sfe1, g

	g = ieor(iand(mssmpart - 1, 2), 3)

	se_WW_nmfv = 0

#ifdef DETAILED_DEBUG
	print *, 'se_WW_nmfv =', se_WW_nmfv
#endif

	if( mssmpart .eq. 1 ) return


	do All1 = g, 6, g
	do Ind1 = g, 3
        se_WW_nmfv = se_WW_nmfv + 
     -   3/(8.D0*Pi)*(Alfa*(A0(MASf2(All1,3))*UASf(All1,Ind1,3)*
     -          UASfC(All1,Ind1,3) + 
     -         A0(MASf2(All1,4))*UASf(All1,Ind1,4)*
     -          UASfC(All1,Ind1,4)))/SW2
	enddo
	enddo

	do Gen1 = g, 3
	do Gen2 = g, 3
        se_WW_nmfv = se_WW_nmfv - 
     -   3/(4.D0*Pi)*(Alfa*CKM(Gen1,Gen2)*CKMC(Gen1,Gen2)*
     -       (A0(Mf2(4,Gen2)) - 
     -         2*B00(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         k2*B1(k2,Mf2(3,Gen1),Mf2(4,Gen2)) + 
     -         B0(k2,Mf2(3,Gen1),Mf2(4,Gen2))*Mf2(3,Gen1)))/SW2
	enddo
	enddo

	do All1 = g, 6, g
	do All2 = g, 6, g
	do Ind1 = g, 3
	do Ind2 = g, 3
	do Ind3 = g, 3
	do Ind4 = g, 3
        se_WW_nmfv = se_WW_nmfv - 
     -   3/(2.D0*Pi)*(Alfa*B00(k2,MASf2(All1,3),MASf2(All2,4))*
     -       CKM(Ind3,Ind1)*CKMC(Ind4,Ind2)*UASf(All1,Ind3,3)*
     -       UASf(All2,Ind2,4)*UASfC(All1,Ind4,3)*
     -       UASfC(All2,Ind1,4))/SW2
	enddo
	enddo
	enddo
	enddo
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_nmfv =', se_WW_nmfv
#endif

	if( mssmpart .eq. 2 ) return


	do Gen1 = 1, 3
        se_WW_nmfv = se_WW_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*(-2*A0(Mf2(2,Gen1)) + 
     -         A0(MSf2(1,1,Gen1)) + 4*B00(k2,0.D0,Mf2(2,Gen1)) - 
     -         2*k2*B1(k2,0.D0,Mf2(2,Gen1))))/SW2
	enddo

	do Gen1 = 1, 3
	do Sfe1 = 1, 2
        se_WW_nmfv = se_WW_nmfv + 
     -   1/(8.D0*Pi)*(Alfa*(A0(MSf2(Sfe1,2,Gen1)) - 
     -         4*B00(k2,MSf2(1,1,Gen1),MSf2(Sfe1,2,Gen1)))*
     -       USf(Sfe1,1,2,Gen1)*USfC(Sfe1,1,2,Gen1))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_nmfv =', se_WW_nmfv
#endif

	if( mssmpart .eq. 3 ) return

        se_WW_nmfv = se_WW_nmfv + 
     -   1/(16.D0*Pi)*(Alfa*CW2*A0(MA02) + Alfa*CW2*A0(Mh02) + 
     -       Alfa*CW2*A0(MHH2) + 2*Alfa*CW2*A0(MHp2) - 
     -       2*Alfa*CW2*(-7 + 4*CW2 + 4*SW2)*A0(MW2) + 
     -       Alfa*CW2*(1 + 12*CW2)*A0(MZ2) + 
     -       4*Alfa*CW2*(-5*k2 + MW2)*SW2*B0(k2,0.D0,MW2) + 
     -       4*Alfa*CW2*MW2*SBA**2*B0(k2,Mh02,MW2) + 
     -       4*Alfa*CBA**2*CW2*MW2*B0(k2,MHH2,MW2) + 
     -       4*Alfa*(CW2**2*(-5*k2 - 2*MZ2) + MW2*SW2**2)*
     -        B0(k2,MW2,MZ2) - 32*Alfa*CW2*SW2*B00(k2,0.D0,MW2) - 
     -       4*Alfa*CW2*B00(k2,MA02,MHp2) - 
     -       4*Alfa*CBA**2*CW2*B00(k2,Mh02,MHp2) - 
     -       4*Alfa*CW2*SBA**2*B00(k2,Mh02,MW2) - 
     -       4*Alfa*CW2*SBA**2*B00(k2,MHH2,MHp2) - 
     -       4*Alfa*CBA**2*CW2*B00(k2,MHH2,MW2) - 
     -       4*Alfa*CW2*(1 + 8*CW2)*B00(k2,MZ2,MW2) - 
     -       8*Alfa*CW2*k2*SW2*B1(k2,0.D0,MW2) - 
     -       8*Alfa*CW2**2*k2*B1(k2,MZ2,MW2))/(CW2*SW2)

	do Cha1 = 1, 2
	do Neu1 = 1, 4
        tmp1 = (Sqrt(2.D0)*UChaC(Cha1,1)*ZNeu(Neu1,2) + 
     -     UChaC(Cha1,2)*ZNeu(Neu1,3))/Sqrt(2.D0)
        tmp2 = (Sqrt(2.D0)*VChaC(Cha1,1)*ZNeu(Neu1,2) - 
     -     VChaC(Cha1,2)*ZNeu(Neu1,4))/Sqrt(2.D0)
        tmp3 = (Sqrt(2.D0)*UCha(Cha1,1)*ZNeuC(Neu1,2) + 
     -     UCha(Cha1,2)*ZNeuC(Neu1,3))/Sqrt(2.D0)
        tmp4 = (Sqrt(2.D0)*VCha(Cha1,1)*ZNeuC(Neu1,2) - 
     -     VCha(Cha1,2)*ZNeuC(Neu1,4))/Sqrt(2.D0)
        se_WW_nmfv = se_WW_nmfv + 
     -   1/(2.D0*Pi)*(-(Alfa*(tmp1*tmp3 + tmp2*tmp4)*
     -          (A0(MNeu2(Neu1)) - 
     -            2*B00(k2,MCha2(Cha1),MNeu2(Neu1)) + 
     -            k2*B1(k2,MCha2(Cha1),MNeu2(Neu1)))) + 
     -       Alfa*B0(k2,MCha2(Cha1),MNeu2(Neu1))*
     -        (-(tmp2*tmp4*MCha2(Cha1)) + 
     -          tmp3*tmp4*MCha(Cha1)*MNeu(Neu1) + 
     -          tmp1*(-(tmp3*MCha2(Cha1)) + 
     -             tmp2*MCha(Cha1)*MNeu(Neu1))))/SW2
	enddo
	enddo

#ifdef DETAILED_DEBUG
	print *, 'se_WW_nmfv =', se_WW_nmfv
#endif

	end

