* SLHAAddDecay.F
* adds a channel to a parent node in the SLHA data structure
* last modified 20 Apr 06 th

#include "SLHAIntern.h"


	subroutine SLHAAddDecay(sd, width, parent,
     &    nchildren, child1_id, child2_id, child3_id, child4_id)
	implicit none
	double precision sd(*), width
	integer parent
	integer nchildren, child1_id, child2_id, child3_id, child4_id

	integer child

	if( parent .le. 0 .or. width .eq. 0 ) return

	child = parent + Decay_Next(parent)

	if( child + nchildren + 1 .ge. LengthDecay ) then
	  print *, "Out of memory in SLHAAddDecay"
	  parent = 0
	  return
	endif

	if( nchildren .ge. 1 ) then
	  Decay(child) = Decay_Entry(child1_id, nchildren + 1)
	  child = child + 1
	  if( nchildren .ge. 2 ) then
	    Decay(child) = Decay_Entry(child2_id, nchildren + 1)
	    child = child + 1
	    if( nchildren .ge. 3 ) then
	      Decay(child) = Decay_Entry(child3_id, nchildren + 1)
	      child = child + 1
	      if( nchildren .ge. 4 ) then
	        Decay(child) = Decay_Entry(child4_id, nchildren + 1)
	        child = child + 1
	      endif
	    endif
	  endif
	endif

	Decay(child) = width
	Decay(parent) = Decay_Entry(Decay_Id(parent), child - parent + 1)
	end


