#if 0
	SLHAData.h
		declarations for data in SUSY Les Houches Accord format
		(see hep-ph/0311123)
		last modified 19 Apr 05 th
#endif


#ifndef __SLHAData_h__
#define __SLHAData_h__

#define invalid -999


#define OffsetModSel 0
#define LengthModSel 9
#define BlockModSel(i) slhadata(OffsetModSel+i)
#define   ModSel_Model		BlockModSel(1)
#define   ModSel_Content	BlockModSel(2)
#define   ModSel_GridPts	BlockModSel(3)
#define   ModSel_Qmax		BlockModSel(4)
#define   ModSel_PDG(n)		BlockModSel(4+n)

#define OffsetSMInputs 9
#define LengthSMInputs 7
#define BlockSMInputs(i) slhadata(OffsetSMInputs+i)
#define   SMInputs_invAlfaMZ	BlockSMInputs(1)
#define     SMInputs_AlfaMZ	  SMInputs_invAlfaMZ
#define   SMInputs_GF		BlockSMInputs(2)
#define   SMInputs_AlfasMZ	BlockSMInputs(3)
#define   SMInputs_MZ		BlockSMInputs(4)
#define   SMInputs_Mf(t)	BlockSMInputs(3+t)
#define     SMInputs_Mtau	  SMInputs_Mf(2)
#define     SMInputs_Mt		  SMInputs_Mf(3)
#define     SMInputs_Mb		  SMInputs_Mf(4)

#define OffsetMinPar 16
#define LengthMinPar 7
#define BlockMinPar(i) slhadata(OffsetMinPar+i)
#define   MinPar_Q		BlockMinPar(1)
#define   MinPar_M0		BlockMinPar(2)
#define     MinPar_Lambda	  MinPar_M0
#define   MinPar_M12		BlockMinPar(3)
#define     MinPar_Mmess	  MinPar_M12
#define     MinPar_M32		  MinPar_M12
#define   MinPar_TB		BlockMinPar(4)
#define   MinPar_signMUE	BlockMinPar(5)
#define   MinPar_A		BlockMinPar(6)
#define     MinPar_N5		  MinPar_A
#define   MinPar_cgrav		BlockMinPar(7)

#define OffsetExtPar 23
#define LengthExtPar 30
#define BlockExtPar(i) slhadata(OffsetExtPar+i)
#define   ExtPar_Q		BlockExtPar(1)
#define   ExtPar_M1		BlockExtPar(2)
#define   ExtPar_M2		BlockExtPar(3)
#define   ExtPar_M3		BlockExtPar(4)
#define   ExtPar_Af(t)		BlockExtPar(3+t)
#define     ExtPar_Atau		  ExtPar_Af(2)
#define     ExtPar_At		  ExtPar_Af(3)
#define     ExtPar_Ab		  ExtPar_Af(4)
#define   ExtPar_MHu2		BlockExtPar(8)
#define   ExtPar_MHd2		BlockExtPar(9)
#define   ExtPar_MUE		BlockExtPar(10)
#define   ExtPar_MA02		BlockExtPar(11)
#define   ExtPar_TB		BlockExtPar(12)
#define   ExtPar_MSS(g,n)	BlockExtPar(g+3*n+9)
#define     ExtPar_MSL(g)	  ExtPar_MSS(g,1)
#define     ExtPar_MSE(g)	  ExtPar_MSS(g,2)
#define     ExtPar_MSQ(g)	  ExtPar_MSS(g,3)
#define     ExtPar_MSU(g)	  ExtPar_MSS(g,4)
#define     ExtPar_MSD(g)	  ExtPar_MSS(g,5)
#define   ExtPar_N5(g)		BlockExtPar(27+g)


#define OffsetMass 53
#define LengthMass 50
#define BlockMass(i) slhadata(OffsetMass+i)
#define   Mass_Mf(t,g)		BlockMass(t+4*g-4)
#define   Mass_MfFlat(i)	BlockMass(i)
#define   Mass_MSf(s,t,g)	BlockMass(s+2*t+8*g+2)
#define   Mass_MSfFlat(i)	BlockMass(i+12)
#define   Mass_MZ		BlockMass(37)
#define   Mass_MW		BlockMass(38)
#define   Mass_Mh0		BlockMass(39)
#define   Mass_MHH		BlockMass(40)
#define   Mass_MA0		BlockMass(41)
#define   Mass_MHp		BlockMass(42)
#define   Mass_MNeu(n)		BlockMass(42+n)
#define   Mass_MCha(c)		BlockMass(46+c)
#define   Mass_MGl		BlockMass(49)
#define   Mass_MGrav		BlockMass(50)


#define OffsetNMix 103
#define LengthNMix 16
#define BlockNMix(i) slhadata(OffsetNMix+i)
#define   NMix_ZNeu(n1,n2)	BlockNMix(n1+4*n2-4)
#define   NMix_ZNeuFlat(i)	BlockNMix(i)


#define OffsetUMix 119
#define LengthUMix 4
#define BlockUMix(i) slhadata(OffsetUMix+i)
#define   UMix_UCha(c1,c2)	BlockUMix(c1+2*c2-2)
#define   UMix_UChaFlat(i)	BlockUMix(i)

#define OffsetVMix 123
#define LengthVMix 4
#define BlockVMix(i) slhadata(OffsetVMix+i)
#define   VMix_VCha(c1,c2)	BlockVMix(c1+2*c2-2)
#define   VMix_VChaFlat(i)	BlockVMix(i)


#define OffsetStauMix 127
#define LengthStauMix 4
#define BlockStauMix(i) slhadata(OffsetStauMix+i)
#define   StauMix_USf(s1,s2)	BlockStauMix(s1+2*s2-2)
#define   StauMix_USfFlat(i)	BlockStauMix(i)

#define OffsetStopMix 131
#define LengthStopMix 4
#define BlockStopMix(i) slhadata(OffsetStopMix+i)
#define   StopMix_USf(s1,s2)	BlockStopMix(s1+2*s2-2)
#define   StopMix_USfFlat(i)	BlockStopMix(i)

#define OffsetSbotMix 135
#define LengthSbotMix 4
#define BlockSbotMix(i) slhadata(OffsetSbotMix+i)
#define   SbotMix_USf(s1,s2)	BlockSbotMix(s1+2*s2-2)
#define   SbotMix_USfFlat(i)	BlockSbotMix(i)

#define SfMix_USf(s1,s2,t)	BlockStauMix(s1+2*s2+4*t-10)
#define SfMix_USfFlat(i,t)	BlockStauMix(i+4*t-8)


#define OffsetAlpha 139
#define LengthAlpha 1
#define BlockAlpha(i) slhadata(OffsetAlpha+i)
#define   Alpha_Alpha		BlockAlpha(1)

#define OffsetHMix 140
#define LengthHMix 5
#define BlockHMix(i) slhadata(OffsetHMix+i)
#define   HMix_Q		BlockHMix(1)
#define   HMix_MUE		BlockHMix(2)
#define   HMix_TB		BlockHMix(3)
#define   HMix_VEV		BlockHMix(4)
#define   HMix_MA02		BlockHMix(5)


#define OffsetGauge 145
#define LengthGauge 4
#define BlockGauge(i) slhadata(OffsetGauge+i)
#define   Gauge_Q		BlockGauge(1)
#define   Gauge_g1		BlockGauge(2)
#define   Gauge_g2		BlockGauge(3)
#define   Gauge_g3		BlockGauge(4)


#define OffsetMSoft 149
#define LengthMSoft 21
#define BlockMSoft(i) slhadata(OffsetMSoft+i)
#define   MSoft_Q		BlockMSoft(1)
#define   MSoft_M1		BlockMSoft(2)
#define   MSoft_M2		BlockMSoft(3)
#define   MSoft_M3		BlockMSoft(4)
#define   MSoft_MHu2		BlockMSoft(5)
#define   MSoft_MHd2		BlockMSoft(6)
#define   MSoft_MSS(g,n)	BlockMSoft(g+3*n+3)
#define     MSoft_MSL(g)	  MSoft_MSS(g,1)
#define     MSoft_MSE(g)	  MSoft_MSS(g,2)
#define     MSoft_MSQ(g)	  MSoft_MSS(g,3)
#define     MSoft_MSU(g)	  MSoft_MSS(g,4)
#define     MSoft_MSD(g)	  MSoft_MSS(g,5)


#define OffsetAe 170
#define LengthAe 2
#define BlockAe(i) slhadata(OffsetAe+i)
#define   Ae_Q			BlockAe(1)
#define   Ae_Atau		BlockAe(2)

#define OffsetAu 172
#define LengthAu 2
#define BlockAu(i) slhadata(OffsetAu+i)
#define   Au_Q			BlockAu(1)
#define   Au_At			BlockAu(2)

#define OffsetAd 174
#define LengthAd 2
#define BlockAd(i) slhadata(OffsetAd+i)
#define   Ad_Q			BlockAd(1)
#define   Ad_Ab			BlockAd(2)

#define Af_Q(t)			BlockAe(2*t-3)
#define Af_Af(t)		BlockAe(2*t-2)


#define OffsetYe 176
#define LengthYe 2
#define BlockYe(i) slhadata(OffsetYe+i)
#define   Ye_Q			BlockYe(1)
#define   Ye_Ytau		BlockYe(2)

#define OffsetYu 178
#define LengthYu 2
#define BlockYu(i) slhadata(OffsetYu+i)
#define   Yu_Q			BlockYu(1)
#define   Yu_Yt			BlockYu(2)

#define OffsetYd 180
#define LengthYd 2
#define BlockYd(i) slhadata(OffsetYd+i)
#define   Yd_Q			BlockYd(1)
#define   Yd_Yb			BlockYd(2)

#define Yf_Q(t)			BlockYe(2*t-3)
#define Yf_Yf(t)		BlockYe(2*t-2)

#define OffsetDMass 182
#define LengthDMass 4
#define BlockDMass(i) slhadata(OffsetDMass+i)
#define   DMass_DeltaMh0	BlockDMass(1)
#define   DMass_DeltaMHH	BlockDMass(2)
#define   DMass_DeltaMA0	BlockDMass(3)
#define   DMass_DeltaMHp	BlockDMass(4)

#define OffsetDAlpha 186
#define LengthDAlpha 1
#define BlockDAlpha(i) slhadata(OffsetDAlpha+i)
#define   DAlpha_DeltaAlpha	BlockDAlpha(1)

#define OffsetDecay 187
#define LengthDecay 4096
#define IdBits 10
#define Decay(i) slhadata(OffsetDecay+i)
#define   Decay_Entry(id,n)	ishft(id,IdBits)+n
#define   Decay_Id(i)		(iand(int(Decay(i)),-2**IdBits)/2**IdBits)
#define   Decay_Next(i)		ibits(int(Decay(i)),0,IdBits)


#define nslhadata 4283

#endif

