class flags
{
 public: 
    int debug, collider_predic, dm_predic, dd_rescal, 
        dd_predic, id_predic, fh_predic ;
};

// CMSSM inputs:

class cmssm
{
public:
    double m0, m12, a0, tanb, scaledep;
    int sgnMu; 
};

// SM and DD inputs: 

class nuisance
{
public:
    double mbottom, mtop, alphamz, alphasmz, ftp_s, ftn_s;
};


// Physical spectrum for testing with experiment:

class susy_spec
{
public:
    double mlh, mhh, mA, mhc, 
        mch1, mch2, mneut1, mneut2, mneut3, mneut4, 
        mseR, mseL, msmuR, msmuL, mstau1, mstau2, 
        msne, msnmu, msntau, 
        msuR, msuL, mscR, mscL, mst1, mst2,
	msdR, msdL, mssR, mssL, msb1, msb2,
        mgluino, SinBmASq;
};


// class softsusy containing the whole output for ds:

class Higgs
{
public:
   double mh, mH, ma, mcH, halpha ;
};

class sfermions
{
public:
    double msu[2][3], msd[2][3], mse[2][3];
    double msnu[3];
    double thetat, thetab, thetatau;    
};    



class neutralino
{
public:
    double mneut[4];
    double mixchi[4][4];
};


class chargino
{
public:
    double mcha[2];
    double thetaL, thetaR;
};


class running
{
public:
      double mtaumz, mbmz, mtmt, mbpole, mtpole, ylsp_tau, 
	ylsp_b, ylsp_top;
};


class standard
{
 public:
    double mUp, mCharm, mDown, mStrange, 
	mElectron, mMuon, mTau;
};


class softpar
{
public:
    double  mu, m1, m2;
    double asofte[3], asoftu[3], asoftd[3], 
           mass2l[3], mass2e[3], mass2q[3], 
	   mass2u[3], mass2d[3];
};

class softsusy
{
public:
    standard sm;
    softpar soft;
    Higgs higgs;
    sfermions sfer;
    neutralino neut;
    chargino charg;
    running run;
    double mgluino;
};

// Error flags from softsusy:

class error
{
public:
    int unphys, oh2;
    int muSqWrongSign, b, noRhoConvergence, tachyon, nonperturbative,
	noMuConvergence, higgsUfb, irqfp, badConvergence;
    int fh;
    int bd;
    error();
};


inline error::error()
    : unphys(0), oh2(0), muSqWrongSign(0), b(0), noRhoConvergence(0),
    tachyon(0), nonperturbative(0), noMuConvergence(0), higgsUfb(0), 
    irqfp(0), badConvergence(0), fh(0), bd(0)
{}

// Class leshouches for passing inputs to FH:

class SM
{
 public:
    double GFermi, alpha_s, MZ, mb, mtop, mtau;
};

class physical
{
 public:
     double  MW, mh0, mH0, mA0, mHp, 
        msdl, msul, mssl, mscl, msb1, mst1, 
        msdr , msur, mssr, mscr, msb2, mst2,
        msel, msnue, msmul, msnumu, mstau1, msnutau, 
        mser,  msmur, mstau2, mgluino,
	mneut1, mneut2, mneut3, mneut4, mch1,
        mch2 , alpha; 
};

class mixings
{
 public:
     double StopMix[2][2], SbotMix[2][2], StauMix[2][2], 
        NMix[4][4], UMix[2][2], VMix[2][2];  
};


class couplings
{
 public:
    double gp, g2, g3, ytq, ybq, ytauq;
};

class softpars
{
 public:
  double m3sq, M1, M2, M3, mH12, mH22, 
        meL, mmuL, mtauL, meR, mmuR, mtauR, 
        mqL1, mqL2, mqL3, 
        muR, mcR, mtR, mdR, msR, mbR,
      aup, ach, at, ado, ast, ab, ael, amu, atau;
};

class susypars
{
  public:
    double mu, tanb, hvev;
};

class renormalization
{
  public:
    double Q;
};

class leshouches_out
{
 public:
    SM SMinputs;
    physical mass;
    mixings mix; 
    couplings coup;
    softpars soft;
    susypars susy;
    renormalization scale;
};


